/* -*- Mode: C -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1988 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/* This file is SYS:EMBEDDING;RPC;GENERIC;MODULES.H. */

/* This file defines the table of modules maintained by RPC.c */

typedef enum {
  NoModule,					/* empty table slot */
  LinkedModule,					/* linked into the program */
  LoadedModule,					/* dynamically loaded & purgeable */
  LoadedModuleWithStaticData } ModuleType;	/* dynamically loaded then kept */

typedef struct {
  long module_number;
  long module_version;
  long when_called;				/* TickCount at most recent call */
  ModuleType type;
  union {
    struct { FunctionPtr handler;		/* Function to call */
	     Ptr static_pointer; } linked;	/* Garbage or address of static data */
#ifdef RPC_LOADABLE_MODULES
    struct { 
      Handle code;				/* Code resource */
      short file; } loaded;			/* Resource file */
    struct { 
      Handle code;				/* Code resource */
      short file;				/* Resource file */
      long handler_offset;			/* Offset to dispatch function */
      long static_offset; } statick;		/* Offset to A4 storage */
#endif
    } u;
  } ModuleDefinition;

extern ModuleDefinition *ModuleTable;		/* Table of loaded modules */
extern long ModuleTableSize;			/* Current number of entries */
