/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * $Log:	autoboot.c,v $
 * Revision 2.5.1.2  93/02/01  12:55:22  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:51:05  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:39:08  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */


#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/autoboot.c,v 2.5.1.2 93/02/01 12:55:22 kaufman Rel $";
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>
#include <stdio.h>
#include "embed.h"
#include "emblib.h"
#include "symbolics_characters.h"

manage_autoboot_input (fp)
     FILE *fp;
{
  static EmbColdLoadChannel *cold_load = NULL;
  static EmbQueue *display_output_queue, *keyboard_input_queue;
  int ch;

  if (cold_load == NULL) {
    cold_load = (EmbColdLoadChannel *) HostPointer(EmbCommAreaPtr->cold_load_channel);
    display_output_queue = (EmbQueue *) HostPointer(cold_load->display_output_queue);
    keyboard_input_queue = (EmbQueue *) HostPointer(cold_load->keyboard_input_queue);
  }

  while (EmbCommAreaPtr->fep_status == RunningFEPStatus &&
	 EmbQueueSpace(keyboard_input_queue) &&
	 !EmbCommAreaPtr->fep_error &&
	 !EmbCommAreaPtr->fep_busy) {
    if ((ch = getc(fp)) == -1) {
      usleep(250000);
      return(1);
    }
    EmbQueuePutWord(keyboard_input_queue, clMakeOp(clsoInputChar, 0, ASCIItoLispM(ch)));
    if (ch == '\n')
      return(0);
  }

  if (EmbCommAreaPtr->fep_error)
    return(-1);
  else
    return(0);
}



/* Character set translation */

int TranslationTable[] = ASCIItoLispMTranslations;

ASCIItoLispM (ch)
     int ch;
{
  register int i;

  for (i = 0; i < sizeof(TranslationTable)/sizeof(int); i++)
    if (ch == TranslationTable[i++])
      return(TranslationTable[i]);

  return(ch);
}

LispMtoASCII (ch)
     int ch;
{
  register int i;

  for (i = 0; i < sizeof(TranslationTable)/sizeof(int); i += 2)
    if (ch == TranslationTable[i+1])
      return(TranslationTable[i]);

  return(ch);
}
