/* -*- Mode: C -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1988 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/* This file is SYS:EMBEDDING;RPC;GENERIC;BSAGENT.H. */

#include "RPC.h"
#include "stdagent.h"

#ifdef RPC_USE_PROTOTYPES
typedef struct BS_XDRAgent {
  XDRAgent_METHODS
  XDRAgent_DATA
  OSErr (*listen) PROTO_ARGS((struct BS_XDRAgent* agent, long* count));
  OSErr (*input) PROTO_ARGS((struct BS_XDRAgent* agent, long* count, char* pointer));
  OSErr (*output) PROTO_ARGS((struct BS_XDRAgent* agent, long* count, char* pointer, Boolean force));
  OSErr (*clear_input) PROTO_ARGS((struct BS_XDRAgent* agent));
} BS_XDRAgent;
#else
typedef struct {
  XDRAgent_METHODS
  XDRAgent_DATA
  FunctionPtr listen, input, output, clear_input;
} BS_XDRAgent;
#endif

#define BS_XDRAgent_listen(agent,count) (*agent->listen)(agent,count)
#define BS_XDRAgent_input(agent,count,pointer) (*agent->input)(agent,count,pointer)
#define BS_XDRAgent_output(agent,count,pointer,force) (*agent->output)(agent,count,pointer,force)
#define BS_XDRAgent_clear_input(agent) (*agent->clear_input)(agent)

extern void BS_XDRAgent_fill_handlers PROTO_ARGS((BS_XDRAgent *));
