/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * $Log:	cold_x.c,v $
 * Revision 2.5.1.2  93/02/01  12:55:24  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:51:10  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:39:19  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/cold_x.c,v 2.5.1.2 93/02/01 12:55:24 kaufman Rel $";
#endif
     
#include <sys/types.h>
#include <setjmp.h>
#include <errno.h>
     
#include "embed.h"
#include "symbolics_env.h"
#include "emblib.h"
#include "life.h"
#include "symbolics_characters.h"
#include "genera.h"
#include "genera-icon-32.xbm"
#include "genera-cptfont.xbm"

#ifdef sun
#include <sys/time.h>
#endif
     
#include <X11/Xlib.h>
#include <X11/Xproto.h>
#include <X11/Xutil.h>
#define XK_MISCELLANY
#define XK_LATIN1
#include <X11/keysymdef.h>
     
#define RUN_LIGHT_Y_SPACE 3	/* Pixels to leave for run bars in cold-load window */
#define RUN_LIGHT_Y_OFFSET (RUN_LIGHT_Y_SPACE-1)

/* These are closely related to pixels_per_run_light as computed in alloc_screen_array,
   but any values smaller than the below (as tend to be computed) look crappy. */
#define RUN_LIGHT_WIDTH 32
#define RUN_LIGHT_SPACING 40

#define DISK_RUN_LIGHT 2
#define PROCESS_RUN_LIGHT 3
#define NETWORK_RUN_LIGHT 5
#define NETBOOT_PROGRESS_BAR 7

static EmbColdLoadChannel *cold_channel = NULL;
static EmbQueue *keyboard_queue = NULL, *display_queue = NULL;
     
static Display *display = NULL;
static Screen *screen;
static Visual *visual;
static Window window, icon_window, root;
static Colormap colormap;
static GC gc, icon_gc, icon_gc_s, icon_gc_c, icon_gc_t;
static Pixmap icon_bitmap = 0, cptfont_bitmap = 0;
static int icon_width = 32, icon_height = 36;
static int char_width, char_height, width = 0, height = 0;
static int loff, toff, roff, boff;
static int lmarg = 3, tmarg = 22, rmarg = 3, bmarg = 3;
static int current_x = 0, current_y = 0;
static int cursor_visible = 0, cursor_frozen = 0, cursor_state = 0, light_state = 0;
static int visibility = 0, icon_visibility = 0;
static int run_light_y, run_light_first_x, run_label_y;
static int progress_bar_first_x, progress_bar_width, run_label_width, run_label_height;
static int progress_bar_numerator_state = 0, progress_bar_denominator_state = 0;
static int progress_bar_length_state = 0, progress_label_length;
static char *progress_label = NULL;
static int meta_mask = 0, super_mask = 0, hyper_mask = 0;
static jmp_buf x_io_error;
     
typedef struct {
  int length;
  char *chars;
} line;
     
static line *screen_array = NULL;
     
static void close_display();
static void display_io_error();
static void alloc_screen_array();
static void redisplay_screen_array();
static void handle_input();
static void handle_output();
static void replay_command_history();
#define show_cursor() show_cursor_internal(EmbCommAreaPtr->fep_cursor)
static void show_cursor_internal();
static void hide_cursor();
static void show_lights();
static void reset_light_state();
static void show_icon();
static void wait();
static void setup_modifier_mapping();

extern void start_cold_x();
extern void stop_cold_x();
void open_display();
void handle_output_command();
void halt_lisp();
     
typedef struct {
  short code;
  KeySym keysym;
} coldmapentry;
     
static coldmapentry coldmap[] = {
SK_Rubout, XK_Delete,
SK_Help, XK_Help,
SK_Backspace, XK_BackSpace,
SK_Tab, XK_Tab,
SK_Line, XK_Linefeed,
SK_Return, XK_Return,
SK_Escape, XK_Escape,
-1, -1};
     
static short fkmap[] = {
SK_Select, SK_Square,
SK_Network, SK_Circle,
SK_Function, SK_Triangle,
SK_Suspend, -1,		/* --- -1 should be SK_Mode_Lock */
SK_Resume, SK_Resume,
SK_Abort, SK_Abort,
-1, -1,			/* --- -1s should be SK_Super */
-1, -1,			/* --- -1s should be SK_Hyper */
SK_Scroll, SK_Page,
SK_Clear_Input, SK_Refresh,
SK_Complete, SK_End,
SK_Help, SK_Help,
/* F13 through F20 are illegal */
-1, -1,
-1, -1,
-1, -1,
-1, -1,
-1, -1,
-1, -1,
-1, -1,
-1, -1,
/* F21 (R1) through F23 (R3) repeat F10 through F12, for Sun Type-3 keyboards */
SK_Clear_Input, SK_Refresh,
SK_Complete, SK_End,
SK_Help, SK_Help,
};
     

     
open_cold_load_display (params)
     struct x_params *params;
{
  atexit(stop_cold_x);
  open_display(params);
  if (display != NULL) {
    replay_command_history();
    return(XConnectionNumber(display));
  } else
    return(-1);
}

manage_x_input (params)
     struct x_params *params;
{
  while (display != NULL && XPending(display))
    handle_input();
  if (display == NULL) {
    /* Display must have closed */
    close_display();
    open_display(params);
  }
  return(display == NULL ? -1 : XConnectionNumber(display));
}

manage_cold_load_output ()
{
  while (EmbQueueFilled(display_queue))
    handle_output();
}

update_cold_load_blinkers ()
{
  show_cursor();
  show_lights(0);
  XFlush(display);
}

setup_x_io_error_handler ()
{
  return(setjmp(x_io_error));
}

void stop_cold_x()
{
  select_disable_on_exit();
  close_display();
}


find_cold_load ()
{
  if (cold_channel && select_disable(EmbGuestPtr(cold_channel)))
    perror("select_disable");

  cold_channel = EmbHostPtr(EmbCommAreaPtr->cold_load_channel);
  if (cold_channel == NULL)
    {
      fprintf(stderr, "No cold load channel.\n");
      exit(1);			/* --- */
    }
  keyboard_queue = EmbHostPtr(cold_channel->keyboard_input_queue);
  display_queue = EmbHostPtr(cold_channel->display_output_queue);

  if (select_enable(EmbGuestPtr(cold_channel)) == -1) {
    perror("select_enable");
    return(-1);
  }
  return(0);
}


#ifdef notdef
static void wait()
{
  fd_set readfds;
  int xfd = XConnectionNumber(display);
  int nfds = (xfd > ivory_fd ? xfd : ivory_fd) + 1;
  struct timeval timeout;
  
  timeout.tv_sec = 0;
  timeout.tv_usec = 250000;
  while ((EmbQueueFilled(display_queue) == 0) &&
	 (XPending(display) == 0))
    {
      XFlush(display);
      FD_ZERO(&readfds);
      FD_SET(xfd, &readfds);
      FD_SET(ivory_fd, &readfds);
      switch (select(nfds, &readfds, NULL, NULL, &timeout))
      {
	case -1:
	  if (errno != EINTR)
	    {	
	      perror("select");
	      abort();
	    }
	  break;
	  
	case 0:
	/* We timed out; go frob the cursor */
	  return;
	  
	default:
	  if (FD_ISSET(xfd, &readfds) && (XPending(display) == 0))
	    display_io_error(display);
	  break;
      }
      
      if (EmbReset(EmbCommAreaPtr))
	{
	  if (select_disable(EmbGuestPtr(cold_channel)))
	    perror("select_disable");
	  find_cold_load();
	  if (select_enable(EmbGuestPtr(cold_channel)) == -1)
	    perror("select_enable");
	}
    }
}
#endif


void open_display(params)
     struct x_params *params;
{
  XWMHints wmhints;
  XSizeHints sizehints;
  XColor color;
  XSetWindowAttributes attributes;
  XGCValues gcv;
  XFontStruct *fontinfo;
  char display_name[BUFSIZ], *cp;
  int screen_no, border_width, w_x, w_y, w_w, w_h, g_flags;

  if (!cold_channel)
    if (find_cold_load() < 0)
      return;
  
  sprintf(display_name, "%s:%d.%d",
	  params->xp_host_name == NULL ? "unix" : params->xp_host_name,
	  params->xp_display == -1 ? 0 : params->xp_display,
	  params->xp_screen == -1 ? 0 : params->xp_screen);
  if ((display = XOpenDisplay(display_name)) == NULL) {
    perror ("XOpenDisplay");
    fprintf (stderr, "Waiting for X server...");
    while (display == NULL) {
      sleep(5);
      display = XOpenDisplay(display_name);
    }
    fprintf (stderr, "Done.");
  }
  
  XSetIOErrorHandler(display_io_error);
  screen_no = XDefaultScreen(display);
  screen = XDefaultScreenOfDisplay(display);
  visual = XDefaultVisualOfScreen(screen);
  root = XRootWindowOfScreen(screen);
  colormap = XDefaultColormapOfScreen(screen);

  setup_modifier_mapping();  

  fontinfo = XLoadQueryFont(display, "genera-cptfont");
  if (fontinfo)
    {
      gcv.font = fontinfo->fid;
      XFreeFontInfo(NULL, fontinfo, 0);
    }
  else
    gcv.font = 0;
  char_width = 8;
  char_height = 12;
  roff = rmarg - 0;
  toff = tmarg + 10;
  loff = lmarg + 0;
  boff = bmarg + 2;
  
  border_width = params->xp_border_width<0 ? 2 : params->xp_border_width;
  if (params->xp_geometry)
    g_flags = XGeometry(display, screen_no, params->xp_geometry, "800x400+0+0",
			border_width, char_width, char_height, roff+loff, toff+boff,
			&w_x, &w_y, &w_w, &w_h);
  else
    { g_flags = 0; w_x = 0; w_y = 0; w_w = 800; w_h = 400; }

  if ((params->xp_foreground_color != NULL)
      && XAllocNamedColor(display, colormap, params->xp_foreground_color, &color, &color))
    gcv.foreground = color.pixel;
  else
    gcv.foreground = XBlackPixelOfScreen(screen);

  if ((params->xp_background_color != NULL)
      && XAllocNamedColor(display, colormap, params->xp_background_color, &color, &color))
    gcv.background = color.pixel;
  else
    gcv.background = XWhitePixelOfScreen(screen);

  if ((params->xp_border_color != NULL)
      && XAllocNamedColor(display, colormap, params->xp_border_color, &color, &color))
    attributes.border_pixel = color.pixel;
  else
    attributes.border_pixel = XBlackPixelOfScreen(screen);

  attributes.background_pixel = gcv.background;
  attributes.event_mask = KeyPressMask|ExposureMask|StructureNotifyMask|
    FocusChangeMask|VisibilityChangeMask;
  attributes.colormap = colormap;
  window = XCreateWindow(display, root, w_x, w_y, w_w, w_h, border_width,
			 CopyFromParent, InputOutput, visual,
			 CWBackPixel|CWBorderPixel|CWEventMask|CWColormap, &attributes);
  icon_window = XCreateWindow(display, root, w_x, w_y, icon_width, icon_height, 0,
			      CopyFromParent, InputOutput, visual,
			      CWBackPixel|CWEventMask|CWColormap, &attributes);

  gc = XCreateGC(display, window, GCForeground|GCBackground|(gcv.font ? GCFont : 0), &gcv);
  icon_gc = XCreateGC(display, icon_window, GCForeground|GCBackground, &gcv);

  if (!gcv.font)
    cptfont_bitmap = XCreateBitmapFromData(display, root, GENERA_CPTFONT_bits,
					   GENERA_CPTFONT_width, GENERA_CPTFONT_height);

  if (XCellsOfScreen(screen) < 16) {
    icon_bitmap = XCreateBitmapFromData(display, icon_window, GeneraIcon32_bits,
					GeneraIcon32_width, GeneraIcon32_height);
    icon_gc_s = icon_gc_c = icon_gc_t = NULL;
  } else {
    icon_bitmap = NULL;
    color.red = 0;
    color.green = 65535;
    color.blue = 0;
    if (XAllocColor(display, colormap, &color)) {
      gcv.foreground = color.pixel;
      icon_gc_s = XCreateGC(display, icon_window, GCForeground, &gcv);
    } else
      icon_gc_s = icon_gc;
    color.red = 65535;
    color.green = 0;
    color.blue = 0;
    if (XAllocColor(display, colormap, &color)) {
      gcv.foreground = color.pixel;
      icon_gc_c = XCreateGC(display, icon_window, GCForeground, &gcv);
    } else
      icon_gc_c = icon_gc;
    color.red = 65535;
    color.green = 0;
    color.blue = 65535;
    if (XAllocColor(display, colormap, &color)) {
      gcv.foreground = color.pixel;
      icon_gc_t = XCreateGC(display, icon_window, GCForeground, &gcv);
    } else
      icon_gc_t = icon_gc;
  }

  if (params->xp_name_fn != NULL &&
      (cp = (*params->xp_name_fn)()) != NULL)
    set_cold_load_name(cp);
  XSetIconName(display, window, params->xp_icon_name);
  wmhints.flags = InputHint|StateHint|IconWindowHint;
  wmhints.input = True;
  wmhints.initial_state = params->xp_iconic == T ? IconicState : NormalState;
  wmhints.icon_window = icon_window;
  XSetWMHints(display, window, &wmhints);
  sizehints.flags = ((g_flags & XValue) ? USPosition : PPosition)
    		    | ((g_flags & WidthValue) ? USSize : PSize);
  sizehints.x = w_x;		/* These are for pre-ICCCM window managers */
  sizehints.y = w_y;
  sizehints.width = w_w;
  sizehints.height = w_h;
  XSetNormalHints(display, window, &sizehints);
  XMapWindow(display, window);
  XFlush(display);
  
  alloc_screen_array(w_w, w_h);
}

set_cold_load_name (name)
     char *name;
{
  if (display != NULL && window != 0)
      XStoreName(display, window, name);
}

static void close_display()
{
  if (display != NULL)
    {
      XCloseDisplay(display);
      display = NULL;
    }
}

void close_display_child_hook ()
{
  if (display != NULL)
    close(XConnectionNumber(display));
}


static void display_io_error(error_display)
Display *error_display;
{
  if (error_display == display) {
    display = NULL;
    longjmp(x_io_error, 0);
  }
}

static void handle_input()
{
  XEvent event;
  KeySym keysym;
  int key = -1, bits = 0;
  coldmapentry *mapp;
  static int first_keypress = 1;
  
  XNextEvent(display, &event);
  switch (event.type)
  {
    case ConfigureNotify:
      if (event.xconfigure.window == window)
	alloc_screen_array(event.xconfigure.width, event.xconfigure.height);
      else if (event.xconfigure.window == icon_window)
	  {
	    icon_width = event.xconfigure.width;
	    icon_height = event.xconfigure.height;
	  }
      break;
    case Expose:
      if (event.xexpose.window == window)
	{
	  if (event.xexpose.y < tmarg) show_lights(1);
	  hide_cursor();
	  redisplay_screen_array((event.xexpose.x-lmarg)/char_width,
				 (event.xexpose.y-tmarg)/char_height,
				 (event.xexpose.x-lmarg+event.xexpose.width-1)/char_width+1,
				 (event.xexpose.y-tmarg+event.xexpose.height-1)/char_height+1);
	  reset_light_state(True);
	  show_lights(1);
	}
      else if (event.xexpose.window == icon_window)
	  show_icon();
      break;
    case KeyPress:
      if (first_keypress)
	{
	/* Disable FEP timer */
	  first_keypress = 0;
	  alarm(0);
	}
      keysym = XLookupKeysym(&event.xkey, 0);
      if (IsModifierKey(keysym) || (keysym == XK_F7) || (keysym == XK_F8)) break;
      if (event.xkey.state & ControlMask) bits |= 1;
      if (event.xkey.state & meta_mask) bits |= 2;
      if (event.xkey.state & super_mask) bits |= 4;
      if (event.xkey.state & hyper_mask) bits |= 8;
      if ((XK_a <= keysym) && (keysym <= XK_z))
	{
	  key = (keysym - XK_a) + 65;
	  if ((bits == 0)
	      ? ((event.xkey.state & (ShiftMask | LockMask)) == 0)
	      : (event.xkey.state & ShiftMask))
	    key = key + 32;
	}
      else if ((XK_F1 <= keysym) && (keysym <= XK_F23))
	  {
	    key = fkmap[2*(keysym-XK_F1) + ((event.xkey.state & ShiftMask) ? 1 : 0)];
	  }
	else
	  {
	    if (event.xkey.state & ShiftMask) keysym = XLookupKeysym(&event.xkey, 1);
	    if ((XK_space <= keysym) && (keysym <= XK_asciitilde))
	      key = keysym;
	    else
	      {
		for (mapp = &coldmap[0]; mapp->code != -1; mapp++)
		  {
		    if (keysym == mapp->keysym)
		      {
			key = mapp->code;
			break;
		      }
		  }
	      }
	  }
      if (key == -1)
	XBell(display, 0);
      else {
	EmbQueuePutWord (keyboard_queue, (clsoInputChar<<24) |
			 ((unsigned long)bits<<12) | (unsigned long)key);
	if ((key == SK_Function) && (bits & 9) == 9) 
	  if (EmbSendGuestReset() == -1)
	    perror("IVORYRESET");
      }
      break;
    case MappingNotify:
      XRefreshKeyboardMapping(&event.xmapping);
      if (event.xmapping.request == MappingModifier)
	setup_modifier_mapping();
      break;
    case VisibilityNotify:
      if (event.xvisibility.window == window)
	visibility = (event.xvisibility.state != VisibilityFullyObscured);
      else if (event.xvisibility.window == icon_window)
	  icon_visibility = (event.xvisibility.state != VisibilityFullyObscured);
      break;
    case FocusIn:
      cursor_frozen = 0;
      show_cursor();
      break;
    case FocusOut:
      show_cursor_internal(1);
      cursor_frozen = 1;
      break;
  }
}


static void alloc_screen_array(new_width_pixels, new_height_pixels)
int new_width_pixels, new_height_pixels;
{
  line *old_screen_array = screen_array;
  int old_width = width;
  int old_height = height;
  int y = 0;
  int new_width, new_height;	/* in lines */
  int pixels_per_run_light;
  
  new_width = (new_width_pixels - (roff+loff))/char_width;
  new_height = (new_height_pixels - (toff+char_height+RUN_LIGHT_Y_SPACE+boff))/char_height;
  
  if ((new_width == old_width) && (new_height == old_height)) return;
  
  screen_array = (line *)malloc(new_height * sizeof(line));
  while (y < new_height)
    {
      screen_array[y].length = 0;
      screen_array[y].chars = malloc(new_width);
      memset(screen_array[y].chars, ' ', new_width);
      if (y < old_height)
	{
	  screen_array[y].length = old_screen_array[y].length < new_width ? old_screen_array[y].length : new_width;
	  memcpy(screen_array[y].chars, old_screen_array[y].chars, screen_array[y].length);
	}
      y++;
    }
  if (old_screen_array != NULL)
    {
      for (y=0; y<old_height; y++)
	free(old_screen_array[y].chars);
      free(old_screen_array);
    }
  cold_channel->character_width = 1;
  cold_channel->line_height = 1;
  cold_channel->display_width = new_width;
  cold_channel->display_height = new_height;
  run_light_y = new_height_pixels - RUN_LIGHT_Y_OFFSET;
  run_label_y = new_height_pixels - RUN_LIGHT_Y_SPACE;
  run_label_height = char_height;
  pixels_per_run_light = (new_width_pixels - (roff+loff)) / 32;
  run_light_first_x = (pixels_per_run_light * 8) + loff;
  run_label_width = new_width_pixels - run_light_first_x - roff;
  progress_bar_first_x = (pixels_per_run_light * 22) + loff;
  progress_bar_width = new_width_pixels - loff - progress_bar_first_x - roff;
  reset_light_state(True);
  EmbQueuePutWord(keyboard_queue, clsoSetSize<<24);
  width = new_width;
  height = new_height;
}


static void redisplay_line(y, x, xlim)
int x, y, xlim;
{
  if (!cptfont_bitmap)
    XDrawImageString(display, window, gc,
		     x*char_width+loff, y*char_height+toff,
		     &screen_array[y].chars[x], xlim-x);
  else
    {
      int cx, wx, wy = y*char_height+tmarg;

      for (cx = x, wx = x*char_width+lmarg; cx<xlim; cx++, wx+=char_width)
	XCopyPlane(display, cptfont_bitmap, window, gc,
		   (char_width-1)*screen_array[y].chars[cx], 0,
		   (char_width-1), char_height, wx, wy, 1);
    }
}


static void redisplay_screen_array(minx, miny, maxx, maxy)
int minx, miny, maxx, maxy;
{
  int y;
  int this_minx = ((0 < minx) ? minx : 0);
  int this_miny = ((0 < miny) ? miny : 0);
  int this_maxy = ((height < maxy) ? height : maxy);
  
  for (y = this_miny; y<this_maxy; y++)
    {
      int this_maxx = ((screen_array[y].length < maxx) ? screen_array[y].length : maxx);
      
      if (this_minx < this_maxx)
	redisplay_line(y, this_minx, this_maxx);
    }
}


static void show_cursor_internal(new_state)
{
  if (visibility && !cursor_frozen)
    {
      if (cursor_visible && (cursor_state != new_state))
	hide_cursor();
      if (!cursor_visible)
	{
	  cursor_state = EmbCommAreaPtr->fep_cursor;  
	  if (cursor_state)
	    XFillRectangle(display, window, gc, current_x*char_width+lmarg, current_y*char_height+tmarg,
			   char_width-1, char_height-1);
	  XDrawRectangle(display, window, gc, current_x*char_width+lmarg, current_y*char_height+tmarg,
			 char_width-1, char_height-1);
	  cursor_visible = 1;
	}
    }
}


static void hide_cursor()
{
  if (cursor_visible)
    {
      XClearArea(display, window, current_x*char_width+lmarg, current_y*char_height+tmarg,
		 char_width, char_height, False);
      redisplay_screen_array(current_x, current_y, current_x+1, current_y+1);
      cursor_visible = 0;
    }
}


static void show_icon()
{
  XPoint tri[3];
  int xoff = icon_width > 32 ? (icon_width-32)/2 : 0;
  
  if (icon_bitmap)
    XCopyPlane(display, icon_bitmap, icon_window, icon_gc, 0, 0, 32, 32, xoff, 0, 1);
  else {
    XFillRectangle(display, icon_window, icon_gc_s, xoff+10, 3, 9, 9);
    XFillArc(display, icon_window, icon_gc_c, xoff+15, 9, 14, 14, 0, 360*64);
    tri[0].x = xoff+3; tri[0].y = 29;
    tri[1].x = xoff+10; tri[1].y = 15;
    tri[2].x = xoff+17; tri[2].y = 29;
    XFillPolygon(display, icon_window, icon_gc_t, tri, 3, Convex, CoordModeOrigin);
  }
}


static void show_lights(force)
int force;
{
  int i, bit;
  int changed = light_state ^ EmbCommAreaPtr->run_lights;
  EmbColdLoadChannel *cls;
  int pb_length, pb_length_change;
  
  light_state = EmbCommAreaPtr->run_lights;
  if (visibility) {
    /* Update run bars in cold-load window */
    if (force || changed)
      for (i = run_light_first_x, bit = 1; bit < 32; i += RUN_LIGHT_SPACING, bit = bit << 1)
	if (force || (changed & bit))
	  if (light_state & bit)
	    XFillRectangle(display, window, gc, i, run_light_y, RUN_LIGHT_WIDTH, 1);
	  else
	    XClearArea(display, window, i, run_light_y, RUN_LIGHT_WIDTH, 1, False);
    /* Update progress bar */
    cls = HostPointer(EmbCommAreaPtr->cold_load_channel);
    if (cls != NULL) {
      if (cls->string_length == 0) {
	if (progress_label != NULL) {
	  /* Clear progress label */
	  XClearArea(display, window, run_light_first_x, run_label_y - run_label_height + 1,
		     run_label_width, run_label_height, FALSE);
	  free(progress_label);
	  progress_label = NULL;
	}
	if (progress_bar_length_state != 0) {
	  /* Clear progress bar */
	  XClearArea(display, window, progress_bar_first_x, run_light_y,
		     progress_bar_width, 1, FALSE);
	  progress_bar_numerator_state = progress_bar_denominator_state =
	    progress_bar_length_state = 0;
	}
      } else {
	/* Update progress label */
	if (progress_label == NULL) {
	  /* Draw run bar labels */
	  XDrawString(display, window, gc,
		      run_light_first_x + (PROCESS_RUN_LIGHT * RUN_LIGHT_SPACING),
		      run_label_y, "Run", 3);
	  XDrawString(display, window, gc,
		      run_light_first_x + (DISK_RUN_LIGHT * RUN_LIGHT_SPACING),
		      run_label_y, "Disk", 4);
	  XDrawString(display, window, gc,
		      run_light_first_x + (NETWORK_RUN_LIGHT * RUN_LIGHT_SPACING),
		      run_label_y, "Net", 3);
	  /* Allocate memory for progress label cache */
	  progress_label = calloc(cls->string_total_size, sizeof(char));
	  progress_label_length = 0;
	}
	if (progress_label_length != cls->string_length ||
	    strcmp(progress_label, cls->string)) {
	  /* Recache progress label */
	  progress_label_length = cls->string_length;
	  strncpy(progress_label, cls->string, progress_label_length);
	  /* Draw new label
	   * Erase old label first so no overwrite */
	  XClearArea(display, window, progress_bar_first_x,
		     run_label_y - run_label_height + 1,
		     progress_bar_width, run_label_height, FALSE);
	  XDrawString(display, window, gc, progress_bar_first_x, run_label_y,
		      progress_label, progress_label_length);
	}
	if (cls->progress_denominator > 0) {
	  /* Update progress bar */
	  if (progress_bar_numerator_state != cls->progress_numerator ||
	      progress_bar_denominator_state != cls->progress_denominator) {
	    progress_bar_numerator_state = cls->progress_numerator;
	    progress_bar_denominator_state = cls->progress_denominator;
	    pb_length = (progress_bar_numerator_state * progress_bar_width) /
	      progress_bar_denominator_state;
	    pb_length_change = pb_length - progress_bar_length_state;
	    if (pb_length_change < 0) {
	      /* Shorten the progress bar */
	      XClearArea(display, window, progress_bar_first_x + pb_length,
			 run_light_y, -pb_length_change, 1, FALSE);
	      progress_bar_length_state = pb_length;
	    } else if (pb_length_change > 0) {
	      /* Lengthen the progress bar */
	      XFillRectangle(display, window, gc,
			     progress_bar_first_x + progress_bar_length_state, run_light_y,
			     pb_length_change, 1);
	      progress_bar_length_state = pb_length;
	    }
	  }
	}
      }
    }
  }
  if (icon_visibility) {
    /* Update run bars in icon */
    if (force || changed)
      for (i = 2, bit = 1; bit < 32; i += 6, bit = bit << 1)
	if (force || (changed & bit))
	  if (light_state & bit)
	    XFillRectangle(display, icon_window, icon_gc, i, 32, 4, 4);
	  else
	    XClearArea(display, icon_window, i, 32, 4, 4, False);
  }      
}

static void reset_light_state (screen_cleared_p)
     int screen_cleared_p;
{
  if (screen_cleared_p == True) {
    progress_bar_numerator_state = progress_bar_denominator_state =
      progress_bar_length_state = 0;
    light_state = 0;
  }
  if (progress_label != NULL) {
    free(progress_label);
    progress_label = NULL;
  }
}


static void replay_command_history ()
{
  int i, have_pos = FALSE;

  if (cold_channel->command_history_wrapped_p)
    i = cold_channel->command_history_index+1;
  else
    i = 0;
  for (; i != cold_channel->command_history_index; i++) {
    /* Watch for history wraparound */
    if (i == COLD_LOAD_HISTORY_SIZE)
      i = 0;

    /* Don't do any output until we know where to put it */
    if (!have_pos && ((cold_channel->command_history[i]>>24) & 0xff) == clsoSetCursorpos)
      have_pos = TRUE;

    /* Do output */
    if (have_pos)
      handle_output_command(cold_channel->command_history[i]);
  }

  reset_light_state(False);
  show_lights(1);
}
			  

static void handle_output()
{
  unsigned long command;
  
  while (EmbQueueFilled(display_queue)) {
      hide_cursor();
      command = EmbQueueTakeWord(display_queue);
      cold_channel->command_history[cold_channel->command_history_index++] = command;
      if (cold_channel->command_history_index == COLD_LOAD_HISTORY_SIZE) {
	cold_channel->command_history_index = 0;
	cold_channel->command_history_wrapped_p = TRUE;
      }

      handle_output_command(command);
    }
}

void handle_output_command (command)
{
  int operator;
  int x, y;
  char c;
  XEvent event;
  
  operator = (command>>24) & 0xff;
  switch (operator) {
    case clsoDrawChar:
    case clsoLozengedChar:
      if ((current_y < height) && (current_x < width)) {
	  if (screen_array[current_y].length <= current_x) {
	      for (x = screen_array[current_y].length; x < current_x; x++) 
		screen_array[current_y].chars[x] = ' ';
	      screen_array[current_y].length = current_x + 1;
	    }
	  c = (char)(command & 0xff);
	  screen_array[current_y].chars[current_x] = c;
	  redisplay_line(current_y, current_x, current_x+1);
	}
      current_x++;
      break;
    case clsoSetCursorpos:
      current_x = command & 0xfff;
      current_y = (command>>12) & 0xfff;
      break;
    case clsoClearRestOfWindow:
      for (y = current_y+1; y<height; y++)
	screen_array[y].length = 0;
      XClearArea(display, window, lmarg, (current_y+1)*char_height+tmarg,
		 width*char_width, (height - (current_y+1))*char_height,
		 False);
      reset_light_state();
    case clsoClearRestOfLine:
      if (current_x < screen_array[current_y].length) {
	  screen_array[current_y].length = current_x;
	  XClearArea(display, window, current_x*char_width+lmarg, current_y*char_height+tmarg,
		     (width - current_x)*char_width, char_height, False);
	}
      break;
    case clsoBeep:
      XBell(display, 0);
      break;
    case clsoSelect:
#ifdef notdef			/* Rejected by Hornig */
      /* Clear screen */
      for (y = 0; y<height; y++)
	screen_array[y].length = 0;
      XClearArea(display, window, lmarg, tmarg,
		 width*char_width, height*char_height+tmarg,
		 False);

      /* Clear history */
      cold_channel->command_history_index = 0;
      cold_channel->command_history_wrapped_p = FALSE;
#endif

      /* Expose display, ring bell */
      XMapRaised(display, window);
      XBell(display, 0);
      break;
    case clsoDeselect:
      event.xclient.type = ClientMessage;
      event.xclient.display = display;
      event.xclient.window = window;
      event.xclient.message_type = XInternAtom(display, "WM_CHANGE_STATE", 0);
      event.xclient.format = 32;
      event.xclient.data.l[0] = IconicState;
      XSendEvent(display, root, False, SubstructureRedirectMask|SubstructureNotifyMask,
		 &event);
      break;
  }
}


int static find_modifier(modmap, code)
XModifierKeymap *modmap;
KeyCode code;
{
  int modifier, i;

  if (code == 0) return -1;
  for (modifier = 0; modifier < 8; modifier++)
    for (i = 0; i < modmap->max_keypermod; i++)
      if (modmap->modifiermap[i+modifier*modmap->max_keypermod] == code)
	return modifier;
  return -1;
}
      
int static find_unused_modifier(modmap)
XModifierKeymap *modmap;
{
  int modifier, i;

  for (modifier = 0; modifier < 8; modifier++)
    {
      for (i = 0; i < modmap->max_keypermod; i++)
	if (modmap->modifiermap[i+modifier*modmap->max_keypermod] != 0)
	  goto label;
      return modifier;
    label:
      continue;
    }
  return -1;
}
      

int static do_modifier(modmapp, changedp, code1, code2)
XModifierKeymap **modmapp;
int *changedp;
KeyCode code1, code2;
{
  int mod = -1;

  mod = find_modifier(*modmapp, code1);
  if (mod == -1)
    mod = find_modifier(*modmapp, code2);
  if (mod != -1)
    return 1<<mod;
  if ((code1 == 0) && (code2 == 0))
    return 0;
  mod = find_unused_modifier(*modmapp);
  if (mod == -1)
    return 0;
  if (code1 != 0)
    {
      *modmapp = XInsertModifiermapEntry(*modmapp, code1, mod);
      *changedp = 1;
    }
  if (code2 != 0)
    {
      *modmapp = XInsertModifiermapEntry(*modmapp, code2, mod);
      *changedp = 1;
    }
  return 1<<mod;
}


void static setup_modifier_mapping()
{
  XModifierKeymap *modmap;
  KeyCode meta_l_code = XKeysymToKeycode(display, XK_Meta_L);
  KeyCode meta_r_code = XKeysymToKeycode(display, XK_Meta_R);
  KeyCode f7_code = XKeysymToKeycode(display, XK_F7);
  KeyCode f8_code = XKeysymToKeycode(display, XK_F8);
  KeyCode alt_l_code = XKeysymToKeycode(display, XK_Alt_L);
  KeyCode alt_r_code = XKeysymToKeycode(display, XK_Alt_R);
  int changed = 0;

  if ((meta_l_code == 0) && (meta_r_code == 0) && alt_l_code && alt_r_code)
    meta_l_code = alt_l_code;

  XGrabServer(display);
  modmap = XGetModifierMapping(display);
  meta_mask = do_modifier(&modmap, &changed,  meta_l_code, meta_r_code);
  if (meta_mask == 0)
    fprintf(stderr, "Unable to allocate a modifier for the Meta key.");
  super_mask = do_modifier(&modmap, &changed, f7_code, 0);
  if (super_mask == 0)
    fprintf(stderr, "Unable to allocate a modifier for the Super key.");
  hyper_mask = do_modifier(&modmap, &changed, f8_code, 0);
  if (hyper_mask == 0)
    fprintf(stderr, "Unable to allocate a modifier for the Hyper key.");
  if (changed)
    XSetModifierMapping(display, modmap);
  XUngrabServer(display);
  XFreeModifiermap(modmap);
}


/* Hacks for genera program */

static int (*XErrorDefaultHandler)() = NULL;

static void SetColdXErrorHandler ()
{
  int ColdXErrorHandler();

  /* Set error handler */
  if (XErrorDefaultHandler == NULL)
    XErrorDefaultHandler = XSetErrorHandler(ColdXErrorHandler);
}

AllowXAccess (params, guest_ip_address)
     struct x_params *params;
     long guest_ip_address;
{
  char display_name[BUFSIZ];
  Display *server;
  XHostAddress guest;

  if (params->xp_host_name == NULL)
    return;

  sprintf(display_name, "%s:%d.%d",
	  params->xp_host_name,
	  params->xp_display == -1 ? 0 : params->xp_display,
	  params->xp_screen == -1 ? 0 : params->xp_screen);
  if ((display = XOpenDisplay(display_name)) == NULL) {
    perror(display_name);
    fprintf(stderr, "Error while opening display: Unable to enable X access to %s from guest\n", display_name);
    return;
  }
  SetColdXErrorHandler();

  guest.family = FamilyInternet;
  guest.length = sizeof(guest_ip_address);
  guest_ip_address = htonl(guest_ip_address);
  guest.address = (char *) &guest_ip_address;

  XAddHost(display, &guest);

  XCloseDisplay(display);
}

DestroyWindow (params, window_id)
     struct x_params *params;
     int window_id;
{
  char display_name[BUFSIZ];
  Display *server;
  XID window;

  if (params->xp_host_name == NULL)
    return;

  sprintf(display_name, "%s:%d.%d",
	  params->xp_host_name,
	  params->xp_display == -1 ? 0 : params->xp_display,
	  params->xp_screen == -1 ? 0 : params->xp_screen);
  if ((display = XOpenDisplay(display_name)) == NULL) {
    perror(display_name);
    fprintf(stderr, "Error while opening display: Unable to shut down guest console on %s\n",
	    display_name);
    return;
  }
  SetColdXErrorHandler();

  window = (XID) window_id;
  XKillClient(display, window);

  XCloseDisplay(display);
}


/* Run lights */

static Display *rl_display = NULL;
static Window rl_window = -1;
static GC rl_gc;
static int rl_nlights;
static unsigned int rl_width, rl_height, rl_x, rl_y, rl_dx, rl_dy;

open_run_lights_display (params, window_id, nlights, width, height, x, y, dx, dy,
			 foreground, background, plane_mask)
     struct x_params *params;
     Window window_id;
     int nlights;
     unsigned int width, height, x, y, dx, dy;
     unsigned long foreground, background, plane_mask;
{
  char display_name[BUFSIZ];
  XGCValues gcv;

  if (window_id != rl_window || rl_display == NULL) {
    /* Close previous display, if any */
    close_run_lights_display();

    if (params->xp_host_name == NULL)
      return;

    /* Open display */
    sprintf(display_name, "%s:%d.%d",
	    params->xp_host_name,
	    params->xp_display == -1 ? 0 : params->xp_display,
	    params->xp_screen == -1 ? 0 : params->xp_screen);
    if ((rl_display = XOpenDisplay(display_name)) == NULL) {
      perror ("XOpenDisplay (for run lights)");
      return;
    }
    rl_window = window_id;
    SetColdXErrorHandler();

    /* Create GContext */
    gcv.foreground = foreground;
    gcv.background = background;
    gcv.plane_mask = plane_mask;
    rl_gc = XCreateGC(rl_display, rl_window, GCForeground|GCBackground|GCPlaneMask, &gcv);
  }

  /* Remember parameters */
  rl_nlights = nlights;
  rl_width = width;
  rl_height = height;
  rl_x = x;
  rl_y = y;
  rl_dx = dx;
  rl_dy = dy;
}

update_run_lights (run_lights_state)
     long *run_lights_state;
{
  XEvent event;
  int i, bit;
  int changed = *run_lights_state ^ EmbCommAreaPtr->run_lights;
  
  *run_lights_state = EmbCommAreaPtr->run_lights;

  if (rl_display != NULL) {

    /* Update run lights */
    for (i = 0, bit = 1; i < rl_nlights; i++, bit = bit << 1)
      if (changed & bit)
	if (*run_lights_state & bit) {
	  /* display drawable GC x y width height */
	  XFillRectangle(rl_display, rl_window, rl_gc,
			 rl_x + (i * rl_dx), rl_y, rl_width, rl_height);
	} else {
	  /* display window x y width height exposures */
	  XClearArea(rl_display, rl_window,
		     rl_x + (i * rl_dx), rl_y, rl_width, rl_height, False);
	}
    XFlush(rl_display);

    /* Drop pending events on the floor */
    for (i = 0; i < 10 && XPending(rl_display); i++)
      XNextEvent(rl_display, &event);
  }
  
  return(0);
}

close_run_lights_display ()
{
  if (rl_display != NULL) {
    XCloseDisplay(rl_display);
    rl_display = NULL;
  }
}


/* Error Handler */

ColdXErrorHandler (display, error)
     Display *display;
     XErrorEvent *error;
{
  extern int manage_run_lights;

  if (display == rl_display) {
    manage_run_lights = 0;
    close_run_lights_display();
  } else if (error->request_code != X_KillClient)
    (*XErrorDefaultHandler)(display, error);
}

