/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * $Log:	config.h,v $
 * Revision 2.5.1.2  93/02/01  12:55:29  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:51:15  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:39:30  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#if !defined(lint) && defined(INCLUDE_FILE_HEADERS)
static char *config_rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/config.h,v 2.5.1.2 93/02/01 12:55:29 kaufman Rel $";
#endif

#define KMEM "/dev/kmem"
#define VMUNIX "/vmunix"

#define MAX_ARGC 20

#define DEFAULT_PROM_DIRECTORY "/usr/share/local/ivory"

void init_config(), read_config();
int open_prom(), open_device_prom();

/* Network filtering modes */
enum filter_mode { all_ip, host_ip, none };

typedef struct {
  /* Booting and Initialization */

  /* Overall Information */
  long host_major_version;
  long host_minor_version;
  long debug_level;		/* Debugging bitflags */

  /* Next two don't belong here, but are kernel-private */
  long communication_memory_size;	/* Number of bytes of memory for comm area */
  /* EmbCommArea *communication_memory_base; /* Base address of communication area */

  /* Memory Allocation: Main Memory for Ivory, Communication Area, Host use */
  long host_buffer_size;	/* Number of bytes of comm area reserved for host buffers */
  long guest_buffer_size;	/* Number of bytes of comm area reserved for guest buffers */
				/* Actual guest buffer size can be larger, this is minimum */
  long guest_extra_buffer_size;	/* Number of bytes before comm area reserved for guest */

  /* Disk */
  fd_set disk_partitions;	/* File descriptors for Ivory disk partitions */
#ifdef MACIVORY_DISK_HACKS
  long disk_cache_size;		/* Number of lines in disk cache */
  long disk_line_size;		/* Number of physical sectors per line */
  long disk_gap_size;		/* Minimum gap to avoid missing rotation between requests */
  long maximum_disk_io_time;	/* Maximum time (in 1/60ths) for continuous disk I/O */
  long disk_io_throttle_interval;	/* Time (in 1/60ths) to "rest" during heavy disk I/O */
#endif

  /* Network */
  long n_transmit_buffers;
  long n_receive_buffers;
  fd_set network_interfaces;
  enum filter_mode network_filter;

  /* Host File */
  int host_file_uid;

  /*  -- add more, e.g. Enable Ivory FPA */

} EmbConfig;


#ifdef _LIFE_

typedef struct {
  /* Kernel configuration */
  IvoryConfig kern;
  /* Embedding configuration */
  EmbConfig emb;
  /* Unalterable parameters */
  char *device;
  char *config_filename;
  /* Other */
  char *prom_directory;
} Config;
  
#endif
