/* -*- Mode: C -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1990 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/* This file is SYS:EMBEDDING;RPC;UNIX;DGAGENT.H.
 *
 * $Log:	dgagent.h,v $
 * Revision 2.5.1.2  93/02/01  12:55:39  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:51:27  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:39:59  kaufman
 * Baseline for Genera 8.3
 * 
 * 
 */

#if !defined(lint) && defined(INCLUDE_FILE_HEADERS)
static char *dg_rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/dgagent.h,v 2.5.1.2 93/02/01 12:55:39 kaufman Rel $";
#endif

#include "RPC.h"

typedef struct {
  long InternalID;
  long ExternalID;
  char *ExternalName;
} IDPair;

typedef struct {
  /* Keep the following in sync with BS_XDRAgent */
  XDRAgent_METHODS
  XDRAgent_DATA
  FunctionPtr listen, input, output, clear_input;
  /* End of BS_XDRAgent */
#ifdef RPC_OS_UNIX
  /* Make it possible to use as a Unix_XDRAgent, sigh. */
  int fd;
#endif
  /* Datagram agent stuff */
  long NameLength;		/* Size of name off end of XDRBlock */
  long InternalIDCounter;	/* Internal Transaction ID counter */
  long IDTableSize;
  IDPair *IDTable;	/* Table of Internal ID to <external ID, name> */
  int ConnectedP;		/* Internal state */
} DG_XDRAgent;

#define DG_XDRAgent_listen(agent,count) (*agent->listen)(agent,count)
#define DG_XDRAgent_input(agent,count,pointer) (*agent->input)(agent,count,pointer)
#define DG_XDRAgent_output(agent,count,pointer,force) (*agent->output)(agent,count,pointer,force)
#define DG_XDRAgent_clear_input(agent) (*agent->clear_input)(agent)
#define DG_XDRAgent_name_size(agent) (agent->NameLength >> 2)

#define XDRDGNamePointer(agent,block) (((char *) XDRDataPointer(agent,block)) + \
				       (XDRDataSize(agent,block) << 2))

extern void DG_XDRAgent_fill_handlers PROTO_ARGS((DG_XDRAgent *));
