/* -*- Mode: C -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1988 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/* This file is SYS:EMBEDDING;RPC;GENERIC;ERROR.H. */

/* Error code definitions for all Symbolics RPC-based facilities.
   This could be split into separate files for each facility later,
   if it gets too large, but I think that is unlikely. */

#include "RPC-OS.h"

/* Define the range of OSErr code numbers used by Symbolics RPC-based facilities.
   Note that these numbers are also known by Lisp. */

#ifdef RPC_OS_MAC
/* There does not appear to be any published convention for assigning numbers.
   This is an apparently unused range with some mnemonic association with Symbolics. */
#define first_Symbolics_error_code 3600
#define last_Symbolics_error_code 3999
#endif

/* Add other operating systems here */

/* Default if nothing specified for a particular operating system */

#ifndef first_Symbolics_error_code
#define first_Symbolics_error_code 3600
#define last_Symbolics_error_code 3999
#endif


/*** Error codes ***/

/* Error codes for RPC itself */

#define guest_not_found_error first_Symbolics_error_code+0
#define command_channel_not_found_error first_Symbolics_error_code+1
#define rpc_transmission_failed_error first_Symbolics_error_code+2
#define rpc_port_not_found_error first_Symbolics_error_code+3
#define rpc_host_not_found_error first_Symbolics_error_code+4

/* Error codes for the remote console facility */

#define application_not_found_error first_Symbolics_error_code+10
#define screen_not_found_error first_Symbolics_error_code+11
#define window_not_found_error first_Symbolics_error_code+12
#define window_already_exists_error first_Symbolics_error_code+13

#define wrong_type_argument_error first_Symbolics_error_code+20
#define wrong_shape_bitmap_error first_Symbolics_error_code+21

/* Error codes for Disk Life Support */

#define unrecognized_command_error first_Symbolics_error_code+30
#define invalid_disk_address_error first_Symbolics_error_code+31

/* Error codes for Serial */

#define output_input_xon_xoff_agreement_error first_Symbolics_error_code+50
#define illegal_baud_rate_error first_Symbolics_error_code+51
#define illegal_number_of_stop_bits_error first_Symbolics_error_code+52
#define illegal_parity_setting_error first_Symbolics_error_code+53
#define illegal_number_of_data_bits_error first_Symbolics_error_code+54
#define serial_port_busy_error first_Symbolics_error_code+55
#define serial_port_not_open_error first_Symbolics_error_code+56
#define serial_port_not_found_error first_Symbolics_error_code+57
#define unimplemented_serial_protocol first_Symbolics_error_code+58
#define illegal_serial_port_specification first_Symbolics_error_code+59
#define synchronous_mode_not_supported first_Symbolics_error_code+60
