/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */
/*
 * $Log:	fepfs.h,v $
 * Revision 2.5.1.2  93/02/01  12:55:55  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:51:45  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:40:39  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#if !defined(lint) && defined(INCLUDE_FILE_HEADERS)
static char *fepfs_rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/fepfs.h,v 2.5.1.2 93/02/01 12:55:55 kaufman Rel $";
#endif


/**** Language supplements ****/

typedef unsigned char byte;
typedef char *string;
#define integer long
#define boolean int

#define false 0
#define true 1

#define ldb(ss,pp,source) ((source)>>(pp))&((1<<(ss))-1)
#define dpb(field,ss,pp,background) (((field)<<(pp)) | ( (background) & (~(((1<<(ss))-1)<<(pp))) ))
#define ceiling(n,d) (((n)+((d)-1))/(d))
#define floor(n,d) ((n)/(d))

void bswap ();
boolean yes_or_no_p ();
void translate_genera_to_unix ();
void translate_unix_to_genera ();


/**** Type definitions ****/

typedef char *disk_buffer;
typedef long disk_address;

typedef struct {
  integer size;
  integer entries;
  integer array[1];
} *datamap;

typedef struct {
  integer bits;
  unsigned integer array [1];
} *bitmap;

integer bitmap_allocated ();


/**** Bootstrapping ****/

typedef struct file_system_representation {
  string device;
  integer descriptor;
  integer disk_size;
  bitmap free_bitmap;
  datamap free_datamap;
  disk_address root_directory_address;
} *file_system;

file_system bootstrap_disk ();
boolean bootstrap_file_system ();


/**** File operations ****/

disk_address lookup_fep_file ();
disk_address create_fep_file ();
void show_fep_directory ();
void install_fep_kernel ();
integer lookup_fep_version ();

typedef struct property_list_representation {
  string name;
  string type;
  integer version;
  integer creation_date;
  string author;
  string comment;
  integer length_in_bytes;
  integer length_in_blocks;
  boolean directory;
  boolean deleted;
  boolean dont_delete;
} *property_list;

typedef struct fep_stream_representation {
  file_system fs;
  string pathname;
  disk_address header;
  property_list properties;
  datamap map;
  integer pointer;
} *fep_stream;

fep_stream open_fep_stream ();
void read_fep_stream ();
void write_fep_stream ();
void seek_fep_stream ();
property_list get_fep_stream_properties ();
void set_fep_stream_properties ();
