/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */
/*
 * $Log:	install-fep-kernel.c,v $
 * Revision 2.5.1.2  93/02/01  12:56:12  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:06  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:41:26  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/install-fep-kernel.c,v 2.5.1.2 93/02/01 12:56:12 kaufman Rel $";
#endif

#include <stdio.h>
#include "fepfs.h"

void main (argc, argv)
int argc;
char **argv;
{
  file_system fs;

  if (argc != 3) {
    fprintf (stderr, "Usage: %s partition-filename fep-kernel-name\n", argv[0]);
    exit (2);
  }
  if ((fs = bootstrap_disk (argv[1], false)) == NULL) {
    fprintf (stderr, "Couldn't open FEP partition file %s: ", argv[1]);
    perror (NULL);
    exit (2);
  }
  if (!bootstrap_file_system (fs)) {
    fprintf (stderr, "Sorry, partition %s does not contain a viable FEP file system.\n",
	     argv[1]);
    exit (2);
  }
  if (lookup_fep_file (fs, argv[2])) {
    install_fep_kernel (fs, argv[2]);
    printf ("Installed %s as the FEP kernel on partition %s.\n", argv[2], argv[1]);
  } else
    fprintf (stderr, "Couldn't find file %s in partition %s.\n", argv[2], argv[1]);
}
