/* -*-Mode: C; Package: C-user -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * Common definitions for UX installation
 *
 * $Log:	install.h,v $
 * Revision 2.5.1.2  93/02/01  12:56:15  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:09  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:41:35  kaufman
 * Baseline for Genera 8.3
 * 
 * 
 */

#if !defined(lint) && defined(INCLUDE_FILE_HEADERS)
static char *install_rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/install.h,v 2.5.1.2 93/02/01 12:56:15 kaufman Rel $";
#endif

/* Product definition
 */
#ifdef sun
#define MAX_UX400_N 9
#define MAX_UX1200_N 8
#define MIN_UX1200_DEVNO 16
#define MULTI_UX_FORMAT "UX12%d%dS"
#define MULTI_UX400_FORMAT "UX40%dS"
#define MULTI_UX1200_FORMAT "UX12%d0S"
#define UX_COPYRIGHT_DATES "1992-1989"
#define UX_NAME "UX400S/UX1200S"
#define UX400_NAME "UX400S"
#define UX1200_NAME "UX1200S"
#endif

#define MAX_INTERFACE_N 10	/* Ludicrously large */
#define MAX_PARTITION_N 10	/* Ludicrously large */


/* Installation parameters */

#define CREATE_UNIX_FILE 1
#define INITIALIZE_PARTITION 2
#define RESTORE_DISTIBUTION 4
#define CREATE_STARTUP_FILES 8

struct partition_params {
  char *filename;
  char *chaos_address, *internet_address;
  int actions;
  int size_in_kbytes;
  long fsid[3];
};

#define SW_FONTS	 1
#define SW_IFEP		 2
#define SW_INCLUDE	 4
#define SW_SOURCE	 8
#define SW_SUN3		16
#define SW_SUN4		32
#define SW_SUN		(SW_SUN3|SW_SUN4)
#define SW_NONE		 0
#define SW_ALL		(SW_FONTS|SW_IFEP|SW_INCLUDE|SW_SOURCE|SW_SUN3|SW_SUN4)

#define SW_AVAILABLE_P(params,sw) (params->available_software & sw)

enum distribution_device { dd_unknown, dd_tape, dd_cdrom };

struct params {
  /* General parameters */
  char *architecture;
  char *kernel_architecture;
  int available_software;
  int defaulting;
  enum distribution_device distribution_device_type;
  char *distribution_device;
  char *distribution_directory;
  char *distribution_host;

  /* Kernel parameters */
  int configure_kernel_p;
  int n_ux400_boards;
  int n_ux1200_boards;
  int ivory_major_device_number;
  char *kernel_build_directory;
  char *source_kernel_name;
  char *ux_kernel_name;

  /* Font parameters */
  int mit_fonts_p;
  char *mit_bin_directory;
  char *mit_font_directory;
  int open_windows_fonts_p;
  /* This is misnamed because Sun changed the way they install Open Windows.
   * It's now the homedirectory for all the Open Windows software. */
  char *open_windows_bin_directory;
  char *open_windows_font_directory;

  /* Partition parameters */
  int create_partitions_p;
  struct partition_params ivory_partitions[MIN_UX1200_DEVNO+MAX_UX1200_N][MAX_PARTITION_N];

  /* Relocation parameters */
  int relocate_p;
  int ivory_life_setuid_p;
  int ivory_servicesd_setuid_p;
  int setgid_p;
  char *relocate_bin_directory;
  char *relocate_etc_directory;
  char *relocate_include_directory;
  char *relocate_lib_directory;
  char *relocate_src_directory;
  char *relocate_ifep_directory;

  /* UNIX startup configuration */
  int install_kernel_p;
  int configure_ivory_life_p;
  char *ivory_interfaces[MIN_UX1200_DEVNO+MAX_UX1200_N][MAX_INTERFACE_N+1];
  int device_special_files_p;
  int configure_startup_p;
  int boot_p;
};

extern struct params ux_installation_params;


/* Utilities in util.c */

int check_file();
int check_integer();
int y_or_n_p();
char *accept_string();
char *file_search();

/* In the interests of keeping lint happy */
typedef union {
  char *string;
  int integer;
} arg;

#define FALSE 0
#define TRUE 1

/* Extended access() bits for check_file() */
#define NONE_OK 8


/* For lint */
#define Fprintf (void) fprintf
#define Printf (void) printf
#define Sprintf (void) sprintf


/* Other stuff */

#define terpri() (void) putchar('\n')

char *sprintf();		/* Should be in stdio.h */
long strtol();
#if defined(_TYPES_) || defined (__sys_types_h)
off_t lseek();
#endif

void determine_font_parameters();
void determine_kernel_build_directory();
void determine_kernel_parameters();
void determine_partition_parameters();
void determine_relocation_parameters();
void determine_unix_startup_parameters();
void require_etc_directory();
void require_ifep_directory();
void require_n_boards();
void require_distribution_device();
