/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * Compile-time definitions for UX driver
 *
 * $Log:	ivory_conf.c,v $
 * Revision 2.5.1.2  93/02/01  13:06:27  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:19  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:23:33  kaufman
 * Baseline for Genera 8.3
 * 
 */

#include "ivory.h"
#if NIVORY > 0

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/ivory_conf.c,v 2.5.1.2 93/02/01 13:06:27 kaufman Rel $";
#endif

#include "sys/types.h"
#include "machine/param.h"
#include "machine/pte.h"
#include "sys/map.h"
#include "sys/socket.h"
#include "sys/user.h"
#include "sys/vmmac.h"
#include "net/if.h"

#ifdef INET
#include "netinet/in.h"
#include "netinet/if_ether.h"
#endif

#include "ivory/embed.h"
#include "ivory/life.h"

#define NEMB_IF (NIVORY * NINTERFACES_PER_IVORY)


/* Structures sized by the number of ivory devices
 * supported by this kernel.
 */

struct mb_device *ivorydinfo[NIVORY];

struct ivory_state ivories[NIVORY];

struct softc if_softc[NEMB_IF];

int n_ivories = NIVORY;

int n_emb_if = NEMB_IF;


/* The u struct is a different size on sun4ms than on other Sun-4s.
 * Rather than shipping another full set of binaries, only access
 * the u structure via the primitives on this page, which are compiled
 * on the target machine.
 */

struct proc *u_procp ()
{
  return(u.u_procp);
}

char p_cursig (procp)
     struct proc *procp;
{
  return(procp->p_cursig);
}

short p_pid (procp)
     struct proc *procp;
{
  return(procp->p_pid);
}

struct file *u_ofile (fd)
     int fd;
{
  return((struct file *) u.u_ofile[fd]);
}

u_lastfile ()
{
  return(u.u_lastfile);
}

void set_u_error (value)
     int value;
{
  u.u_error = value;
  return;
}


/* Memory mapping works differently on the Sun4ms */

caddr_t map_mailbox(flags)
    int flags;
{
  u_long kmx;
  u_int vpagenum;

#ifdef sun4m
    /* This code only works in SunOS 4.1.2 and later */
    return((caddr_t) map_regs(flags, sizeof(long), 0xd) );
#else
    /* This code doesn't work on Sun-4/6xx models */
    kmx = rmalloc(kernelmap, 1);
    vpagenum = btoc((Sysbase))+kmx;
    mapin(&Sysmap[kmx], vpagenum, btoc(flags)|PGT_VME_D32,
	      btoc(sizeof(long)), PG_V|PG_KW);
    return((caddr_t) kmxtob(kmx));
#endif
}
#endif
