/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * Network life-support for the embedded host
 *
 * $Log:	ivory_network.c,v $
 * Revision 2.5.1.2  93/02/01  12:56:40  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:27  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:42:12  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#include "ivory.h"
#if NIVORY > 0

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/ivory_network.c,v 2.5.1.2 93/02/01 12:56:40 kaufman Rel $";
#endif

#include "sys/types.h"
#include "sys/param.h"
#include "sys/file.h"
#include "sys/ioctl.h"
#include "sys/socket.h"
#include "sys/stream.h"
#include "sys/user.h"
#include "sys/vnode.h"
#include "net/if.h"
#include "net/if_arp.h"
#include "netinet/in.h"
#include "netinet/if_ether.h"

#include "embed.h"
#include "life.h"

struct epacket {
  long size;
  char data[EPACKETDATALEN];
};

/* Initialize the net-life code */
void InitializeNetworkLifeII(EmbCommAreaPtr, ivory_unit)
     EmbCommArea *EmbCommAreaPtr;
     int ivory_unit;
{
  EmbPtr cptr;
  EmbChannel *cp;
  EmbNetChannel *network;
  extern struct ivory_state ivories[];

  /* Finish up  network channels */
  for (cptr = EmbCommAreaPtr->channel_table; cptr != NullEmbPtr; cptr = cp->next) {
    cp = (EmbChannel *) HostPointer(cptr);
    if (cp->type == EmbNetworkChannelType) {
      network = (EmbNetChannel *) cp;
      InitializeNetworkChannelII(EmbCommAreaPtr, network, ivory_unit); 
      if (!network->unit) {
	ivories[ivory_unit].net_channel = network;
	ivories[ivory_unit].net_channel_ptr = GuestPointer(network);
      }
#ifdef IVORY_DEBUG
      DBG(DBG_INIT)
	printf("initialized network unit %d\n", network->unit);
#endif
    }
  }
}

/* From fd, find pointer to STREAMS write queue */
static queue_t *fd_queue_head (fd, ivory_unit)
     int fd, ivory_unit;
{
  extern struct module_info ivory_net_module_info;
  extern struct ivory_state ivories[];
  struct stdata *sp;
  struct file *fp;
  struct vnode *vp;
  queue_t *q;

  fp = u_ofile(fd);
  if (fp && fp->f_type == DTYPE_VNODE) {
    vp = (struct vnode *) fp->f_data;
    if (vp && vp->v_type == VCHR) {
      sp = (struct stdata *) vp->v_stream;
      /* --- Should run down queue looking for Solstice net module */
      q = sp->sd_wrq->q_next;
      RD(q)->q_ptr = (char *) &ivories[ivory_unit];
      qenable(q);
      return(q);
    }
  }
  return(0);
}

InitializeNetworkChannelII (EmbCommAreaPtr, channel, ivory_unit)
     EmbCommArea *EmbCommAreaPtr;
     EmbNetChannel *channel;
     int ivory_unit;
{
  queue_t *q;
  
  if (!channel->initialized_p) {
    /* Finish initializing channel */
    channel->xmit_host_to_guest_queue_ptr = (EmbQueue *) HostPointer(channel->xmit_host_to_guest_queue);
    channel->xmit_guest_to_host_queue_ptr = (EmbQueue *) HostPointer(channel->xmit_guest_to_host_queue);
    channel->recv_host_to_guest_queue_ptr = (EmbQueue *) HostPointer(channel->recv_host_to_guest_queue);
    channel->recv_guest_to_host_queue_ptr = (EmbQueue *) HostPointer(channel->recv_guest_to_host_queue);

    if (((int) channel->network_queue) == -1) {
      channel->network_queue = NULL;
      channel->interface = NULL;
    } else {
      /* Dig out queue pointer based on file descriptor */
      if ((q = fd_queue_head((int) channel->network_queue, ivory_unit)) == NULL) {
#ifdef IVORY_DEBUG
	printf("network interface fd %d is not a STREAMS queue\n", channel->network_queue);
#endif
	return(-1);
      }
      channel->network_queue = (PtrV) q;
      channel->interface = (PtrV) q->q_ptr;
    }
    channel->initialized_p = 1;
  }

  return(0);
}


/* Guest transmission support */

/* Emit an epacket to the external network, by passing it to the
 * sol_net module on top of a NIT STREAM */
static external_transmit (EmbCommAreaPtr, channel, epacket)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     EmbNetChannel *channel;
     struct epacket *epacket;
{
  struct msgb *proto = NULL, *data;	/* STREAMS message buffers */
  queue_t *q = (struct queue *) channel->network_queue;
  int data_size;
  struct sockaddr *sock;

  if (q == NULL) {
    /* Life support has no network interfaces to outside world */
    return(1);
  }
  
  if ((proto = allocb(sizeof(struct sockaddr), BPRI_MED)) == 0 ||
      (data = allocb((int)epacket->size, BPRI_MED)) == 0) {
    /* Recover more gracefully in the future? */
    if (proto != NULL)
      freeb(proto);
#ifdef IVORY_DEBUG
    DBG(DBG_NET_DROP) printf("Packet drop - allocb()\n");
#endif
    return(1);
  }

  /* Set up "control" (M_PROTO) part of message:
   * This is a block as large as a struct sockaddr, whose data is the ether_header
   * to be put on the frame. */
  proto->b_rptr = proto->b_wptr = proto->b_datap->db_base;
  sock = (struct sockaddr *) proto->b_wptr;
  sock->sa_family = AF_UNSPEC;
  bcopy(epacket->data, (char *) sock->sa_data, (int) sizeof(struct ether_header));
  proto->b_wptr += sizeof(struct sockaddr);
  proto->b_datap->db_type = M_PROTO;
  proto->b_cont = data;

  /* Set up data (M_DATA) part of message.
   * This is the rest of the frame (after the ether_header).  Note that the
   * SunOS 4.0 nit_if(4) manual page lies: it says that the ether_header should
   * be replicated here, when testing shows that it should not. */
  data->b_rptr = data->b_wptr = data->b_datap->db_base;
  data_size = epacket->size - sizeof(struct ether_header);
  bcopy(epacket->data+sizeof(struct ether_header), (char *) data->b_wptr, data_size);
  data->b_wptr += data_size;
  data->b_datap->db_type = M_DATA;
  data->b_cont = NULL;

  /* Stuff onto NIT queue.  (Top module is guaranteed to be sol_net module.) */
  (*q->q_qinfo->qi_putp)(q, proto);

#ifdef IVORY_DEBUG
  DBG(DBG_NET_QUEUE|DBG_NET_XMIT) {
    extern int queueflag;
    queue_t *qp;

    for (qp = q; qp; qp = qp->q_next)
      printf("%s %s flg 0%o sz %d%s",
	     qp == q ? "putp" : " ->",
	     qp->q_qinfo->qi_minfo->mi_idname,
	     qp->q_flag,
	     qsize(qp),
	     qp->q_next ? "" : "\n");
  }
#endif
  return(0);
}

#ifdef IVORY_EMBIF
static internal_transmit (EmbCommAreaPtr, channel, epacket)
     EmbCommArea *EmbCommAreaPtr;
     EmbNetChannel *channel;
     struct epacket *epacket;
{
  int i;
  int bcopy();
  extern struct ivory_state ivories[];

  /* If necessary, allocate an emb interface for this channel */
  if (channel->emb_if_unit == -1)
    if (channel->guest_primary_protocol == -1)
      return(0);
    else
      channel->emb_if_unit = InitializeEmbInterface(EmbCommAreaPtr, channel);

  /* If there's an emb interface for this channel, transmit the packet to it */
  if (channel->emb_if_unit >= 0)
    emb_receive(EmbCommAreaPtr, (int) channel->emb_if_unit,
	        epacket->data, (int) epacket->size);

  /* Transmit the packet to any other Ivories */
  for (i = 0; i < n_ivories; i++)
    if (ivories[i].EmbCommArea != EmbCommAreaPtr &&
	ivories[i].config.enable_Ivory != 0 &&
	ivories[i].net_channel_ptr != NullEmbPtr)
      NetReceiver(ivories[i].EmbCommArea,
		  (EmbNetChannel *) (((long *)ivories[i].EmbCommArea)
				     + ivories[i].net_channel_ptr),
		  epacket->size, bcopy, (caddr_t) epacket->data, (caddr_t) epacket->size);

  return(0);
}
#endif

static dispatch_epacket (EmbCommAreaPtr, channel, epacket)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     EmbNetChannel *channel;
     struct epacket *epacket;
{
  struct ether_header *eh = (struct ether_header *) epacket->data;
#ifdef IVORY_EMBIF
  register struct ether_addr *ep, *dst;
  register int i;
#endif
#ifdef IVORY_DEBUG
  char *cp;
#endif

#ifdef IVORY_EMBIF
  dst = &eh->ether_dhost;
  if (!ether_cmp(dst, &etherbroadcastaddr)) {
    /* Ethernet broadcasts are sent to both interfaces */
    internal_transmit(EmbCommAreaPtr, channel, epacket);
    external_transmit(EmbCommAreaPtr, channel, epacket);
#ifdef IVORY_DEBUG
    cp = "int&ext";
#endif
  } else {
    for (ep = (struct ether_addr *) EmbCommAreaPtr->host_ether_addrs, i = 0;
	 i < EmbCommAreaPtr->n_host_ether_addrs; ep++, i++)
      if (!ether_cmp(dst, ep)) {
	/* Ethernet address matches one of the host's */
	internal_transmit(EmbCommAreaPtr, channel, epacket);
#ifdef IVORY_DEBUG
	cp = "int";
#endif
	goto dispatched;
      }

    /* Default is to send the packet to the real network */
    external_transmit(EmbCommAreaPtr, channel, epacket);
#ifdef IVORY_DEBUG
    cp = "ext";
#endif
  }
#else /* IVORY_EMBIF */
  external_transmit(EmbCommAreaPtr, channel, epacket);
#ifdef IVORY_DEBUG
  cp = "only";
#endif
#endif /* IVORY_EMBIF */

 dispatched:

#ifdef IVORY_DEBUG
  DBG(DBG_NET_XMIT) {
    printf(":OUT  %s  bytes %d  type %x  src %x:%x:%x:%x:%x:%x  dst %x:%x:%x:%x:%x:%x\n",
	   cp,
	   epacket->size,
	   eh->ether_type,
	   eh->ether_shost.ether_addr_octet[0],
	   eh->ether_shost.ether_addr_octet[1],
	   eh->ether_shost.ether_addr_octet[2],
	   eh->ether_shost.ether_addr_octet[3],
	   eh->ether_shost.ether_addr_octet[4],
	   eh->ether_shost.ether_addr_octet[5],
	   eh->ether_dhost.ether_addr_octet[0],
	   eh->ether_dhost.ether_addr_octet[1],
	   eh->ether_dhost.ether_addr_octet[2],
	   eh->ether_dhost.ether_addr_octet[3],
	   eh->ether_dhost.ether_addr_octet[4],
	   eh->ether_dhost.ether_addr_octet[5]);
  }
#endif
  return;
}

/* Transmit everything in the xmit_guest_to_host_queue
 * Note that this is guaranteed to be called from IvoryLife() via
 * a guest-to-host signal, running in the (kernel-bound) life
 * support process. */
void NetTransmitter (EmbCommAreaPtr, ivory_unit, channel)
     EmbCommArea *EmbCommAreaPtr;
     int ivory_unit;		/*ARGSUSED*/
     EmbNetChannel *channel;
{
  EmbPtr epkt;			/* buf to xmit */
  struct epacket *epacket;	/* useful pointer to same */
  queue_t *q = (struct queue *) channel->network_queue;

  /* If the receive queue is wedged (probably due to a host-to-guest
   * buffer shortage), reenable it */
  if (q != NULL && !canput(RD(q))) {
    qenable(RD(q));
#ifdef IVORY_DEBUG
    DBG(DBG_NET_QUEUE) printf("output reenabled receive queue\n");
#endif
  }
  
  for (;;) {
    if (EmbQueueSpace(EmbCommAreaPtr, channel->xmit_host_to_guest_queue_ptr) == 0) {
      int sig;

      /* Delay servicing transmit requests until the guest makes some
	 space in the queue for returning empty packets */
      sig = channel->xmit_guest_to_host_queue_ptr->signal;
      if (sig > -1)
	EmbCommAreaPtr->reawaken |= (long)1 << sig;

      /* Send a wakeup to the Ethernet Receiver process so
	 emb-ethernet-recycle-packets will be called asap */
      EmbSendSignal(EmbCommAreaPtr, channel->recv_host_to_guest_queue_ptr->signal);
      break;
    }
    
    epkt = EmbQueueTakeWord(EmbCommAreaPtr, channel->xmit_guest_to_host_queue_ptr);
    if (epkt == NullEmbPtr || epkt == 0L) {
      break;
    }

    /* From here, a packet can be put out on the network or put in the
     * "input queue" of the software point-to-point interface.  Ethernet
     * broadcast packets go to both places, packets destined for (one of)
     * the host's ethernet address(es) go to the sw interface, and all
     * other packets go to the network. */
    epacket = (struct epacket *) HostPointer(epkt);
    dispatch_epacket(EmbCommAreaPtr, channel, epacket);

    /* recycle this packet */
    EmbQueuePutWord(EmbCommAreaPtr, channel->xmit_host_to_guest_queue_ptr, epkt);
  }

  /* Update ethernet meters */
  if (channel->interface != NULL) {
    register struct ifnet *ifnet = (struct ifnet *) channel->interface;

    channel->if_ierrors = ifnet->if_ierrors;
    channel->if_oerrors = ifnet->if_oerrors;
    channel->if_collisions = ifnet->if_collisions;
  }
}

/* Guest reception support */

NetReceiver (EmbCommAreaPtr, channel, pktlen, helper, arg0, arg2)
     EmbCommArea *EmbCommAreaPtr;
     EmbNetChannel *channel;
     int pktlen;
     int (*helper)();
     caddr_t arg0, arg2;
{
  EmbPtr buf;
  struct epacket *qepacket;
  int s;
#ifdef IVORY_DEBUG
  static int packet_waiting = 0;
#endif

  /* If Lisp isn't up yet, throw away any incoming packets */
  if (EmbCommAreaPtr->guest_status == UninitializedGuestStatus ||
      !GuestIsRunningLisp(EmbCommAreaPtr)) {
#ifdef IVORY_DEBUG
    if (packet_waiting != 1) {
      DBG(DBG_NET_DROP) printf("Packet drop -- guest down\n");
      packet_waiting = 1;
    }
#endif
    return(0);
  }

  if (EmbQueueFilled(EmbCommAreaPtr, channel->recv_guest_to_host_queue_ptr) == 0) {
    /* Send a wakeup to the Ethernet Receiver process so
       emb-ethernet-recycle-packets will be called asap */
    EmbSendSignal(EmbCommAreaPtr, channel->recv_host_to_guest_queue_ptr->signal);
#ifdef IVORY_DEBUG
    if (packet_waiting != 2) {
      DBG(DBG_NET_RECV) printf("signal %d for recv guest->host\n",
			       channel->recv_host_to_guest_queue_ptr->signal);
      packet_waiting = 2;
    }
#endif
    return(1);
  }
#ifdef IVORY_DEBUG
  packet_waiting = 0;
#endif

  if (channel->status & EmbNet_status_guest_ready) {
    /* Prevent ethernet receiver interrupts while we fiddle queues */
    s = splimp();
    /* --- MacIvory checked xmit-host-to-guest-queue here as well, punt that */
    if (EmbQueueSpace(EmbCommAreaPtr, channel->recv_host_to_guest_queue_ptr)) {
      /*--- Note packet dropped if can't allocate embedded memory or queue space */
      if (pktlen > sizeof(qepacket->data)) {
	splx(s);
#ifdef IVORY_DEBUG
	DBG(DBG_NET_DROP) printf("NetReceiver(): %d-byte epacket too big\n", pktlen);
#endif
	return(0);
      }
      
      buf = EmbQueueTakeWord(EmbCommAreaPtr, channel->recv_guest_to_host_queue_ptr);
      if (buf != NullEmbPtr && buf != 0) {
	/* Non-intuitive argument order to helper function is so receive_pkt()
	   in ivory_stream.c can pass bcopy as its helper */
	qepacket = (struct epacket *) HostPointer(buf);
	(*helper)(arg0, qepacket->data, arg2);
	qepacket->size = pktlen;
#ifdef IVORY_DEBUG
	DBG(DBG_NET_RECV) {
	  struct ether_header *eh = (struct ether_header *) qepacket->data;
		
	  printf(":IN  buf %d  bytes %d  type %x  src %x:%x:%x:%x:%x:%x  dst %x:%x:%x:%x:%x:%x\n",
		 buf, qepacket->size,
		 eh->ether_type,
		 eh->ether_shost.ether_addr_octet[0],
		 eh->ether_shost.ether_addr_octet[1],
		 eh->ether_shost.ether_addr_octet[2],
		 eh->ether_shost.ether_addr_octet[3],
		 eh->ether_shost.ether_addr_octet[4],
		 eh->ether_shost.ether_addr_octet[5],
		 eh->ether_dhost.ether_addr_octet[0],
		 eh->ether_dhost.ether_addr_octet[1],
		 eh->ether_dhost.ether_addr_octet[2],
		 eh->ether_dhost.ether_addr_octet[3],
		 eh->ether_dhost.ether_addr_octet[4],
		 eh->ether_dhost.ether_addr_octet[5]);
	}
#endif
	EmbQueuePutWord(EmbCommAreaPtr, channel->recv_host_to_guest_queue_ptr, buf);
      } else {
	channel->if_dropped++;
#ifdef IVORY_DEBUG
	DBG(DBG_NET_DROP) printf("Packet drop - null emb buf\n");
#endif
      }
    } else {
	channel->if_dropped++;
#ifdef IVORY_DEBUG
      DBG(DBG_NET_DROP)
	/* Timing window here, but it's only debugging output */
	printf("Packet drop - no room in %s_host_to_guest_queue\n",
	       EmbQueueSpace(EmbCommAreaPtr, channel->recv_host_to_guest_queue_ptr) ? "xmit" : "recv");
#endif IVORY_DEBUG
    }
    splx(s);
  }
#ifdef IVORY_DEBUG
  else DBG(DBG_NET_DROP) printf("Packet drop - guest not ready\n");
#endif
  return(0);
}

void NetReceiverWakeup (EmbCommAreaPtr, ivory_unit, channel)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     int ivory_unit;
     EmbNetChannel *channel;
{
  queue_t *q = (struct queue *) channel->network_queue;

  if (q != NULL) {
    q = RD(q);

    /* If the receive queue is wedged (probably due to a recv
     * buffer shortage), reenable it */
    if (!canput(q)) {
      qenable(q);
#ifdef IVORY_DEBUG
      DBG(DBG_NET_QUEUE) printf("NetReceiverWakeup: Unwedged queue\n");
#endif
    }
#ifdef IVORY_DEBUG
    else
      DBG(DBG_NET_QUEUE) printf("NetReceiverWakeup: Queue not wedged\n");
#endif
  }
#ifdef IVORY_DEBUG
  else
    DBG(DBG_NET_QUEUE) printf("NetReceiverWakeup: No queue\n");
#endif
}

#endif				/* NIVORY > 0 */
