/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * Life-support process hacking
 *
 * $Log:	ivory_process.c,v $
 * Revision 2.5.1.2  93/02/01  12:56:42  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:29  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:42:17  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#include "ivory.h"
#if NIVORY > 0

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/ivory_process.c,v 2.5.1.2 93/02/01 12:56:42 kaufman Rel $";
#endif

#include "sys/types.h"
#include "sys/time.h"
#include "sys/param.h"
#include "sys/resource.h"
#include "sys/syscall.h"
#include "sys/user.h"
#include "sys/wait.h"
#include "setjmp.h"
#include "stdio.h"
#include "strings.h"

#include "embed.h"
#include "life.h"

WakeupProcesses (EmbCommAreaPtr, unit)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     int unit;
{
  extern struct ivory_state ivories[];

  if (ivories[unit].master_proc)
    wakeup((caddr_t) ivories[unit].master_proc);
  if (ivories[unit].network_proc)
    wakeup((caddr_t) ivories[unit].network_proc);
  if (ivories[unit].disk_proc)
    wakeup((caddr_t) ivories[unit].disk_proc);
}

ResetSubProcesses (EmbCommAreaPtr, unit)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     int unit;
{
  extern struct ivory_state ivories[];

  wakeup((caddr_t) ivories[unit].network_proc);
  wakeup((caddr_t) ivories[unit].disk_proc);
}

void KillSubProcesses (EmbCommAreaPtr, unit)
     EmbCommArea *EmbCommAreaPtr; /*ARGSUSED*/
     int unit;
{
  extern struct ivory_state ivories[];

  if (ivories[unit].network_proc != NULL) {
#ifdef IVORY_DEBUG
    DBG(DBG_PROCESS) printf("nuking network pid %d\n", p_pid(ivories[unit].network_proc));
#endif IVORY_DEBUG
    psignal(ivories[unit].network_proc, SIGKILL);
    ivories[unit].network_proc = NULL;
  }
  if (ivories[unit].disk_proc != NULL) {
#ifdef IVORY_DEBUG
    DBG(DBG_PROCESS) printf("nuking disk pid %d\n", p_pid(ivories[unit].disk_proc));
#endif IVORY_DEBUG
    psignal(ivories[unit].disk_proc, SIGKILL);
    ivories[unit].disk_proc = NULL;
  }

}

#endif				/* NIVORY > 0 */
