/* -*-Mode: C; Package: C-user -*- */
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1990 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * UX kernel configuration and compilation
 *
 * $Log:	kernel-config.c,v $
 * Revision 2.5.1.2  93/02/01  12:56:48  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:37  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:42:36  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/kernel-config.c,v 2.5.1.2 93/02/01 12:56:48 kaufman Rel $";
#endif

#include <sys/types.h>
#include <sys/conf.h>
#include <sys/file.h>
#include <sys/stat.h>
#define nlist nlist_foo
#include <a.out.h>
#undef nlist
#include <errno.h>
#include <nlist.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include "install.h"

#define SYMORDER "/usr/ucb/symorder"

#ifdef FINDDEVNO
static struct nlist nl_cdevsw[] = {
#define NL_CDEVSW 0
  {"_cdevsw"},
#define NL_IVORYOPEN 1
  {"_ivoryopen"},
  NULL,
};
#endif

static struct nlist nl_version[] = {
#define NL_VERSION 0
  {"_version"},
  NULL,
};

/* Ugly kernel grubbing */

char *lookup_kernel_name()
{
  static char buf[BUFSIZ];
  char *cp, *dp;
  int fd;

  buf[0] = '\0';
  if (nlist("/vmunix", nl_version) == -1) {
    return(NULL);
  }

  if ((fd = open("/dev/kmem", O_RDONLY)) == -1) {
    return(NULL);
  }

  if (lseek(fd, (off_t) nl_version[NL_VERSION].n_value, L_SET) == -1L) {
    (void) close(fd);
    return(NULL);
  }

  if (read(fd, buf, BUFSIZ) == -1) {
    (void) close(fd);
    return(NULL);
  }

  (void) close(fd);

  if ((cp = index(buf, '(')) == NULL)
    return(NULL);
  cp++;
  if ((dp = index(cp, ')')) == NULL)
    return(NULL);
  *dp = '\0';
  return(cp);
}

#ifdef FINDDEVNO
find_ivory_device_number (kernel)
     char *kernel;
{
  int i, fd;
  int devno = -1;
  /*long dev[sizeof(struct cdevsw)/sizeof(long)];*/
  struct exec hdr;
  struct cdevsw dev;
  
#define Dperror(a) perror(a)

  if (nlist(kernel, nl_cdevsw) == -1) {
    return(-1);
  }

  if ((fd = open(kernel, O_RDONLY)) == -1) {
    Dperror(kernel);
    return(-1);
  }

  if (read(fd, &hdr, sizeof(hdr)) == -1) {
    Dperror("read");
    return(-1);
  }

  i = (nl_cdevsw[NL_CDEVSW].n_value - 0x0f004000/* - N_DATADDR(hdr)*/) + N_DATOFF(hdr);
  if (lseek(fd, (off_t) i, L_SET) == -1L) {
    Dperror("kernel seek");
    goto done;
  }
printf("Sought to %x, io %x\n", i, nl_cdevsw[NL_IVORYOPEN].n_value);

  for (devno = 0; ; devno++) {
    if ((i = read(fd, (char *) &dev, sizeof(dev))) == -1) {
      Dperror("read");
      return(-1);
    }
if (devno < 3 || devno == 72)
  printf("%d: %d bytes op %x cl %x r %x w %x\n", devno, i, dev.d_open, dev.d_close, dev.d_read, dev.d_write);

    if (dev.d_open ==  0 || devno == 100) {
printf("%d devices, but no luck.\n", devno);
      devno = -1;
      break;
    } else if ((long) dev.d_open == nl_cdevsw[NL_IVORYOPEN].n_value)
      break;
  }

 done:
  (void) close(fd);
  return(devno);
}
#endif


/* Impertinent question support */

int check_kernel_directory (path, architecture, arg1)
     char *path;
     arg *architecture, arg1;	/*ARGSUSED*/
{
  int tmp;
  char buf[BUFSIZ];

  /* Check that directory exists and has an OBJ subdirectory */
  if (!access(path, F_OK)) {
    Sprintf(buf, "%s/%s/OBJ", path, architecture->string);
    if (!access(buf, F_OK))
      return(0);
    else {
      tmp = errno;

      Fprintf(stderr, "\n>> %s does not appear to be a kernel build directory:\n\t", path);
      errno = tmp;
      perror(buf);
    }
  } else
    perror(path);

  return(-1);
}

check_kernel_name (name, kernel_dir, architecture)
     char *name;
     arg *kernel_dir, *architecture;
{
  char buf[BUFSIZ];
  int tmp;

  Sprintf(buf, "%s/%s/conf/%s", kernel_dir->string, architecture->string, name);
  if (!access(buf, R_OK))
    return(0);
  else {
    tmp = errno;
    Fprintf(stderr, "\n>> %s does not appear to be a kernel name:\n\t", name);
    errno = tmp;
    perror(buf);
  }

  return(-1);
}

check_kernel_architecture (arch, ignore0, ignore1)
     char *arch;
     arg *ignore0, *ignore1;	/* ARGSUSED */
{
  char buf[BUFSIZ];
  int tmp;

  if (!strcmp(arch, "sun4") || !strcmp(arch, "sun4m"))
    return(0);
  else {
    Fprintf(stderr, "\n>> %s is not a valid kernel architecture.\n", arch);
    Fprintf(stderr, ">> Valid architectures are \"sun4\" and \"sun4m\".\n");
  }

  return(-1);
}

void require_n_boards (params, building_kernel_p)
     struct params *params;
     int building_kernel_p;
{
  char buf[BUFSIZ];
  arg arg0, arg1;
  int first_time = TRUE;

  if (params->n_ux400_boards != 0 || params->n_ux1200_boards != 0)
    return;

  do {
    if (first_time)
      first_time = FALSE;
    else
      Printf("\n>> You must choose at least one %s board or one %s board.\n",
	     UX400_NAME, UX1200_NAME);
    
    /* How many UX400Ses? */
    Sprintf(buf, "How many %s boards %s support",
	    UX400_NAME, building_kernel_p ? "should this kernel" : "do you wish to");
    arg0.integer = 0;
    arg1.integer = MAX_UX400_N;
    params->n_ux400_boards = atoi(accept_string(buf, "1", check_integer, &arg0, &arg1));
    
    /* How many UX1200Ses? */
    Sprintf(buf, "How many %s boards %s support",
	    UX1200_NAME, building_kernel_p ? "should this kernel" : "do you wish to");
    arg0.integer = 0;
    arg1.integer = MAX_UX1200_N;
    params->n_ux1200_boards = atoi(accept_string(buf, "1", check_integer, &arg0, &arg1));
  } while (params->n_ux400_boards == 0 && params->n_ux1200_boards == 0);
}

void determine_kernel_build_directory (params)
     struct params *params;
{
  char *kernel_dir;
  arg arg0;

  kernel_dir = file_search(S_IFDIR, "/usr/share/sys","/usr/sys","/sys", NULL);
  arg0.string = params->kernel_architecture;
  kernel_dir = accept_string("Where is your kernel build directory", kernel_dir,
			     check_kernel_directory, &arg0, (arg *)NULL);
  params->kernel_build_directory = kernel_dir;

#ifdef sun3
    params->kernel_architecture = params->architecture;
#else
    params->kernel_architecture =
      accept_string("What kernel architecture does this machine use",
		    params->architecture, check_kernel_architecture,
		    NULL, NULL);
#endif

}

void determine_kernel_parameters (params)
     struct params *params;
{
  char *source_kernel_name = NULL;
  char buf[BUFSIZ];
  arg arg0, arg1;
  int tmp;

  terpri();

  while (1) {

    Sprintf(buf, "Do you wish to build a UNIX kernel with support for the %s",
		   UX_NAME);
    if ((params->configure_kernel_p = y_or_n_p(buf, 1)) == 0)
      return;

    /* How many boards? */
    require_n_boards(params, TRUE);

    /* Determine kernel build directory */
    determine_kernel_build_directory(params);

    /* Determine source kernel name */
    if ((source_kernel_name = lookup_kernel_name()) == NULL) {
      /* If we can't grok /vmunix and GENERIC is there, default the default to GENERIC */
      Sprintf(buf, "%s/%s/conf/GENERIC",
		     params->kernel_build_directory, params->kernel_architecture);
      if (!access(buf, R_OK))
	source_kernel_name = "GENERIC";
    }
    arg0.string = params->kernel_build_directory;
    arg1.string = params->kernel_architecture;
    source_kernel_name = accept_string("What kernel usually runs on this machine",
				       source_kernel_name, check_kernel_name,
				       &arg0, &arg1);
    params->source_kernel_name = source_kernel_name;

    /* Generate UX kernel name */
    if (params->n_ux1200_boards == 0) {
      /* UX400-only kernel */
      if (params->n_ux400_boards == 1)
	params->ux_kernel_name = UX400_NAME;
      else {
	Sprintf(buf, MULTI_UX400_FORMAT, params->n_ux400_boards);
	params->ux_kernel_name = strdup(buf);
      }
    } else if (params->n_ux400_boards == 0) {
      /* UX1200-only kernel */
      if (params->n_ux1200_boards == 1)
	params->ux_kernel_name = UX1200_NAME;
      else {
	Sprintf(buf, MULTI_UX1200_FORMAT, params->n_ux1200_boards);
	params->ux_kernel_name = strdup(buf);
      }
    } else {
      /* Mixed support kernel */
      Sprintf(buf, MULTI_UX_FORMAT, params->n_ux1200_boards, params->n_ux400_boards);
      params->ux_kernel_name = strdup(buf);
    }

    /* To configure and build a kernel, we need write access to the
     * build directory, its arch/conf and OBJ subdirectory, and the specific kernel's
     * build directory (if any). */
    if (access(params->kernel_build_directory, W_OK)) {
      tmp = errno;
      Fprintf(stderr, "\n>> Can't build a kernel, because you don't have\n");
      Fprintf(stderr, "   permission to write into the kernel build directory:\n\t");
      errno = tmp;
      perror(params->kernel_build_directory);
      continue;
    }

    Sprintf(buf, "%s/%s/conf", params->kernel_build_directory, params->kernel_architecture);
    if (access(buf, W_OK)) {
      tmp = errno;
      Fprintf(stderr, "\n>> Can't build a kernel, because you don't have permission\n");
      Fprintf(stderr, "   to write into the kernel configuration directory:\n\t");
      errno = tmp;
      perror(buf);
      continue;
    }

    Sprintf(buf, "%s/%s/OBJ", params->kernel_build_directory, params->kernel_architecture);
    if (access(buf, W_OK)) {
      tmp = errno;
      Fprintf(stderr, "\n>> Can't build a kernel, because you don't have permission\n");
      Fprintf(stderr, "   to write into the kernel objects directory:\n\t");
      errno = tmp;
      perror(buf);
      continue;
    }

    Sprintf(buf, "%s/%s/%s",
		   params->kernel_build_directory, params->kernel_architecture,
		   params->ux_kernel_name);
    if (access(buf, W_OK) && errno != ENOENT) {
      tmp = errno;
      Fprintf(stderr, "\n>> Can't build a kernel, because you don't have\n");
      Fprintf(stderr, "   permission to write into the %s build directory:\n\t",
		     params->ux_kernel_name);
      errno = tmp;
      perror(buf);
      continue;
    }

    /* This is odd, I know */
    break;
  }
}



install_kernel_binaries(params)
     struct params *params;
{
  char source[BUFSIZ], dest[BUFSIZ];

  Sprintf(source, "%s/%s/OBJ", params->distribution_directory, params->architecture);
  Sprintf(dest, "%s/%s/OBJ", params->kernel_build_directory, params->kernel_architecture);
  Printf("Updating kernel binaries...");
  (void) fflush(stdout);
  if (update_directory(source, dest, 1) == -1)
    return(-1);

  /* Install the one kernel source file that's not precompiled,
   * and the include files it depends on.
   */
  Sprintf(dest, "%s/ivory", params->kernel_build_directory);
  if (require_directory(dest, 1) == -1)
    return(-1);
  Sprintf(source, "%s/src/ivory_conf.c", params->distribution_directory);
  if (copy_file(source, dest) == -1)
    return(-1);
  Sprintf(source, "%s/src/life.h", params->distribution_directory);
  if (copy_file(source, dest) == -1)
    return(-1);
  Sprintf(source, "%s/src/embed.h", params->distribution_directory);
  if (copy_file(source, dest) == -1)
    return(-1);

  return(0);
}

configure_kernel (params)
     struct params *params;
{
  if (!params->configure_kernel_p)
    return(0);
  terpri();

  /* Install the kernel binaries only when we're doing relocations */
  if (SW_AVAILABLE_P(params, SW_SUN) && install_kernel_binaries(params) == -1)
    return(-1);
  
  if (configure_ux_kernel(params) == -1)
    return(-1);

  return(0);
}



/* State machine for updating sun/conf.c */

static int ivorydevno = 0;

conf_next_state (state, line)
     int state;
     char *line;
{
  switch(state) {
  case 0:			/* Haven't seen #include "ivory.h" yet */
    if (token_match(line, "#include", "\"ivory.h\"", NULL) ||
	token_match(line, "#include", "<ivory.h>", NULL))
      return(10);

  case 10:			/* Seen #include, looking for #if */
    /* --- Should we require state 10 here? */
    if (token_match(line, "#if", "NIVORY", ">", "0", NULL))
      return(20);

  case 20:			/* Seen #if, looking for #else */
    if (state == 20 && token_match(line, "#else", NULL))
      return(30);

  case 30:			/* Seen #else, looking for #endif */
    if ((state == 20 || state == 30) && token_match(line, "#endif", NULL))
      return(40);

  case 40:			/* Seen #endif, looking for seltrue() */
    /* Be nice not to look for seltrue() until after bdevsw[],
     * but it's not worth the hair. */
    if (token_match(line, "extern", "int", "seltrue", "()", NULL))
      return(45);

  case 45:			/* Seen seltrue(), looking for struct cdevsw */
    if (token_match(line, "struct", "cdevsw", "cdevsw", NULL))
      return(50);

  case 50:			/* In cdevsw, looking for ivory entry */
    if (state == 50)
      if (token_match(line, "ivoryopen", NULL))
	return(60);
      else if (token_match(line, "}", ";", NULL))
	/* Found end of cdevsw! */
	return(10000);
      else if (token_match(line, "}", ",", NULL))
	/* Count preceding entries, so we know ivory's device number */
	ivorydevno++;

  case 60:			/* In cdevsw ivory entry */
    if (state == 60 && token_match(line, "}", ",", NULL))
      return(10000);

  case 10000:			/* All done */
    return(state);

  default:
    Fprintf(stderr, "Unknown conf.c state %d!\n", state);
    return(-1);
  }

}

conf_state_transition (to, direction, line, out)
     int to, direction;		/*ARGSUSED*/
     char *line;
     FILE *out;
{
  int copy_lines_p = 1;

#ifdef notdef
  switch(to) {
  case 0:
  case 10:
  case 20:
  case 30:
  case 40:
  case 45:
  case 50:
  case 60:
  case 10000:
    Printf("state %s to %d", direction > 0 ? "up" : "down", to);
    if (line != NULL)
      Printf(" at %s", line);
    else
      terpri();
    break;
  }
#endif

  switch (to) {
  case 0:
    break;

  case 10:			/* #include "ivory.h" */
    if (line == NULL)
      line = "#include \"ivory.h\"\n";
    fputs(line, out);
    break;

  case 20:			/* #if NIVORY > 0 */
    if (line == NULL)
      line = "#if NIVORY > 0\n";
    fputs(line, out);
    copy_lines_p = 0;		/* Rewrite #if ... #else ourselves */
    break;

  case 30:			/* #else */
    if (line == NULL)
      line = "#else\n";
    Fprintf(out,
	    "/* Device driver for Symbolics %s.  Copyright (c) %s Symbolics, Inc.*/\n",
	    UX_NAME, UX_COPYRIGHT_DATES);
    fputs("extern int ivoryopen(), ivoryclose(), ivoryioctl(), ivorymmap();\n", out);
    fputs("extern int ivoryread(), ivorywrite(), ivoryselect();\n", out);
    fputs(line, out);
    copy_lines_p = 0;		/* Rewrite #else ... #endif ourselves */
    break;
    
  case 40:			/* #endif */
    if (line == NULL)
      line = "#endif\n\n";
    fputs("#define ivoryopen nodev\n", out);
    fputs("#define ivoryclose nodev\n", out);
    fputs("#define ivoryioctl nodev\n", out);
    fputs("#define ivorymmap 0\n", out);
    fputs("#define ivoryread nodev\n", out);
    fputs("#define ivorywrite nodev\n", out);
    fputs("#define ivoryselect seltrue\n", out);
    fputs(line, out);
    break;

  case 45:			/* seltrue() */
    if (line != NULL)
      /* If we didn't see seltrue(), don't worry about it.  The only
       * reason we look for it is that things look prettier if we put
       * the ivory #define's &c ahead of the seltrue() declaration. */
      fputs(line, out);
    break;

  case 50:			/* cdevsw */
    if (line == NULL) {
      Fprintf(stderr, "Internal error parsing conf.c: struct cdevsw not found!\n");
      return(-1);
    }
    fputs(line, out);
    break;

  case 60:			/* ivoryopen */
    /* Rewrite the cdevsw entry
     * If line == NULL, there wasn't already an ivory entry,
     * so write the surrounding pair of brackets as well. */
    if (line == NULL) fputs("    {\n", out);
    Fprintf(out, "\tivoryopen,\tivoryclose,\tivoryread,\tivorywrite,\t/*%d*/\n",
	    ivorydevno);
    fputs("\tivoryioctl,\tnodev,\t\tivoryselect,\tivorymmap,\n", out);
    fputs("\t0,\n", out);
    if (line == NULL) fputs("    },\n", out);
    copy_lines_p = 0;
    break;

  case 10000:			/* All done */
    if (line)
      fputs(line, out);
    break;
  }
  
  return(copy_lines_p);
}
  

/* State machine for updating sun/conf.c */

str_conf_next_state (state, line)
     int state;
     char *line;
{
  switch(state) {

  case 0:			/* Haven't seen #include "ivory.h" yet */
    if (token_match(line, "#include", "\"ivory.h\"", NULL) ||
	token_match(line, "#include", "<ivory.h>", NULL))
      return(10);

  case 10:			/* Seen #include, looking for #if */
    /* --- Should we require state 10 here? */
    if (token_match(line, "#if", "NIVORY", ">", "0", NULL))
      return(20);

  case 20:			/* Seen #if, looking for #endif */
    if (state == 20 && token_match(line, "#endif", NULL))
      return(30);

  case 30:			/* Seen #endif, looking for fmodsw */
    if (token_match(line, "struct", "fmodsw", "fmodsw", NULL))
      return(40);

  case 40:			/* In fmodsw, looking for IvoryNet entry */
    /* --- Should we require state 40 here? */
    if (token_match(line, "#if", "NIVORY", ">", "0", NULL))
      return(50);

  case 50:			/* Seen fmodsw #if, looking for #endif */
    if (state == 50 && token_match(line, "#endif", NULL))
      return(60);

  case 60:			/* Seen #endif, look for beginning of Sun fmodsw entries */
    if ((state > 30 && state <= 60) &&
	token_match(line, "#if", "NNBUF", ">", "0", NULL))
      return(10000);

  case 10000:			/* All done */
    return(state);

  default:
    Fprintf(stderr, "Unknown str_conf.c state %d!\n", state);
    return(-1);
  }

}

str_conf_state_transition (to, direction, line, out)
     int to, direction;		/*ARGSUSED*/
     char *line;
     FILE *out;
{
  int copy_lines_p = 1;

#ifdef notdef
  switch(to) {
  case 0:
  case 10:
  case 20:
  case 30:
  case 40:
  case 50:
  case 60:
  case 10000:
    Printf("state %s to %d", direction > 0 ? "up" : "down", to);
    if (line != NULL)
      Printf(" at %s", line);
    else
      terpri();
    break;
  }
#endif

  switch (to) {
  case 0:
    break;

  case 10:			/* #include "ivory.h" */
    if (line == NULL)
      line = "#include \"ivory.h\"\n";
    fputs(line, out);
    break;

  case 20:			/* #if NIVORY > 0 */
    if (line == NULL)
      line = "#if\tNIVORY > 0\n";
    fputs(line, out);
    copy_lines_p = 0;		/* Rewrite #if ... #endif ourselves */
    break;

  case 30:			/* #endif */
    if (line == NULL)
      line = "#endif\n\n";
    Fprintf(out, "/* Network module for Symbolics %s life support.\n", UX_NAME);
    Fprintf(out, " * Copyright (c) %s Symbolics, Inc. */\n", UX_COPYRIGHT_DATES);
    fputs("extern struct streamtab ivorynetinfo;\n", out);
    fputs(line, out);
    break;

  case 40:			/* fmodsw */
    if (line == NULL) {
      Fprintf(stderr, "Internal error parsing str_conf.c: struct fmodsw not found!\n");
      return(-1);
    }
    fputs(line, out);
    break;

  case 50:			/* #if NIVORY > 0 */
    if (line == NULL)
      line = "#if\tNIVORY > 0\n";
    fputs(line, out);
    copy_lines_p = 0;		/* Rewrite #if ... #endif ourselves */
    break;

  case 60:			/* #endif */
    if (line == NULL)
      line = "#endif\n";
    fputs("\t{ \"IvoryNet\",\t&ivorynetinfo },\n", out);
    fputs(line, out);
    break;

  case 10000:			/* All done */
    if (line)
      fputs(line, out);
    break;
  }
  
  return(copy_lines_p);
}
  

/* State machine for files.cmn */

files_next_state (state, line)
     int state;
     char *line;
{

  switch (state) {
  case 0:			/* Not looking at ivory line */
  case 10:			/* Comment lines */
  case 20:			/* ivory lines */
    /* Add to the first conditional when the copyright gets updated */
    if (token_match(line, "#", "Device", "driver", "and", "life-support", NULL) ||
	token_match(line, "#", "Copyright", "(c)", "1989", "Symbolics", NULL) ||
	token_match(line, "#", "Copyright", "(c)", "1990-1989", "Symbolics", NULL))
      return(10);
    else if (token_match(line, "ivory/", NULL))
      return(20);
    else
      return(0);

  case 10000:			/* All done */
    return(10000);
  }
  /*NOTREACHED*/
}

files_state_transition (to, direction, line, out)
     int to, direction;		/*ARGSUSED*/
     char *line;
     FILE *out;
{
  int copy_lines_p = 1;

#ifdef notdef
  switch(to) {
  case 0:
  case 10:
  case 20:
  case 10000:
    Printf("state %s to %d", direction > 0 ? "up" : "down", to);
    if (line != NULL)
      Printf(" at %s", line);
    else
      terpri();
    break;
  }
#endif

  switch (to) {
  case 0:
    if (line != NULL)
      fputs(line, out);
    break;

  case 10:
  case 20:
    copy_lines_p = 0;
    break;

  case 10000:
    Fprintf(out, "# Device driver and life-support for Symbolics %s.\n", UX_NAME);
    Fprintf(out, "# Copyright (c) %s Symbolics, Inc.\n", UX_COPYRIGHT_DATES);
    fputs("ivory/if_emb.c\t\toptional ivory\n", out);
    fputs("ivory/ivory.c\t\toptional ivory device-driver\n", out);
    fputs("ivory/ivory_buf.c\toptional ivory\n", out);
    fputs("ivory/ivory_conf.c\toptional ivory\n", out);
    fputs("ivory/ivory_disk.c\toptional ivory\n", out);
    fputs("ivory/ivory_embed.c\toptional ivory\n", out);
    fputs("ivory/ivory_life.c\toptional ivory\n", out);
    fputs("ivory/ivory_network.c\toptional ivory\n", out);
    fputs("ivory/ivory_process.c\toptional ivory\n", out);
    fputs("ivory/ivory_signal.c\toptional ivory\n", out);
    fputs("ivory/ivory_stream.c\toptional ivory\n", out);
    fputs("ivory/ivory_reset.c\toptional ivory\n", out);
    break;
  }

  return(copy_lines_p);
}


/* State machine for updating kernel config file
 * Due to a design weakness in the state machine routines,
 * a preexisting kernel ident line will be properly updated, but
 * no ident will be generated if there isn't one in the source file.
 * Also, we don't fix the comment before an ident line in the GENERIC
 * config file that says "Name this kernel GENERIC". These are pretty minor.  */

/* Required components in Solstice configuration file */
static int config_flags = 0;
#define CONFIG_CLONE 1
#define CONFIG_SNIT  2
#define CONFIG_PF    4
#define CONFIG_INET  8

config_next_state (state, line)
     int state;
     char *line;
{
  /* Check for required components */
  if (state != 10 && state != 20 && state != 30) {
    if (token_match(line, "pseudo-device", "clone", NULL))
      config_flags |= CONFIG_CLONE;
    if (token_match(line, "pseudo-device", "snit", NULL))
      config_flags |= CONFIG_SNIT;
    if (token_match(line, "pseudo-device", "pf", NULL))
      config_flags |= CONFIG_PF;
    if (token_match(line, "options", "INET", NULL))
      config_flags |= CONFIG_INET;
  }

  switch(state) {
  case -10:			/* One-shot state for kernel ident */

  case 0:			/* Notice leading empty comment line */
    if (token_match(line, "ident", NULL))
      return(-10);
    else if (!strcmp(line, "#\n"))
      return(10);

  case 10:			/* Symbolics comment */
    if (token_match(line, "#", "Support", "for", "the", "Symbolics", NULL))
      return(20);

  case 20:			/* ivory device lines */
    if (token_match(line, "device", "ivory", NULL))
      return(30);

  case 30:
    if (state == 30)
      if (token_match(line, "csr", NULL) ||
	  token_match(line, "flags", NULL) ||
	  token_match(line, "priority", NULL) ||
	  token_match(line, "vector", NULL))
	/* Must be a continuation line */
	return(30);

  case 10000:			/* All done */
    /* States -10, 10, and 30 are one-shots */
    if (state == -10 || state == 10 || state == 30)
      /* Reevaluate as if at state 0 */
      return(config_next_state(0, line));
    return(state);

  default:
    Fprintf(stderr, "Unknown kernel config file state %d!\n", state);
    return(-1);
  }

}

config_state_transition (to, direction, line, out)
     int to, direction;
     char *line;
     FILE *out;
{
  int copy_lines_p = 1;

#ifdef notdef
  switch(to) {
  case -10:
  case 0:
  case 10:
  case 20:
  case 10000:
    Printf("state %s to %d", direction > 0 ? "up" : "down", to);
    if (line != NULL)
      Printf(" at %s", line);
    else
      terpri();
    break;
  }
#endif

  switch (to) {
  case -10:
    Fprintf(out, "ident\t\t\"%s\"\n", ux_installation_params.ux_kernel_name);
    break;

  case 0:
    if (direction == -1)
      fputs("#\n", out);
    if (line != NULL)
      fputs(line, out);
    break;

  case 10:
  case 20:
  case 30:
    copy_lines_p = 0;
    break;

  case 10000:			/* All done */
    fputs("#\n", out);
    Fprintf(out, "# Support for the Symbolics %s.  Copyright (c) %s Symbolics, Inc.\n",
	    UX_NAME, UX_COPYRIGHT_DATES);
    fputs("#\n", out);
    /* Any required support previously missing */
    if (!(config_flags & CONFIG_CLONE))
      fputs("pseudo-device clone\n", out);
    if (!(config_flags & CONFIG_SNIT))
      fputs("pseudo-device snit\n", out);
    if (!(config_flags & CONFIG_PF))
      fputs("pseudo-device pf\n", out);
    if (!(config_flags & CONFIG_INET))
      fputs("options INET\n", out);
    switch (ux_installation_params.n_ux400_boards) {
    case 9:
      fputs("device\t\tivory8 at vme32d32 ? csr 0xfab90000 flags 0xfaba0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xf2\n", out);
    case 8:
      fputs("device\t\tivory7 at vme32d32 ? csr 0xfab50000 flags 0xfab60000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xf1\n", out);
    case 7:
      fputs("device\t\tivory6 at vme32d32 ? csr 0xfaad0000 flags 0xfaae0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xf0\n", out);
    case 6:
      fputs("device\t\tivory5 at vme32d32 ? csr 0xfa9d0000 flags 0xfa9e0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xef\n", out);
    case 5:
      fputs("device\t\tivory4 at vme32d32 ? csr 0xfabd0000 flags 0xfabe0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xee\n", out);
    case 4:
      fputs("device\t\tivory3 at vme32d32 ? csr 0xfaf90000 flags 0xfafa0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xed\n", out);
    case 3:
      fputs("device\t\tivory2 at vme32d32 ? csr 0xfaf50000 flags 0xfaf60000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xec\n", out);
    case 2:
      fputs("device\t\tivory1 at vme32d32 ? csr 0xfaed0000 flags 0xfaee0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xeb\n", out);
    case 1:
      fputs("device\t\tivory0 at vme32d32 ? csr 0xfadd0000 flags 0xfade0000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xea\n", out);
      break;
    }
    switch (ux_installation_params.n_ux1200_boards) {
    case 8:
      fputs("device\t\tivory23 at vme32d32 ? csr 0xfdec0000 flags 0xfdf00000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe8\n", out);
    case 7:
      fputs("device\t\tivory22 at vme32d32 ? csr 0xfdcc0000 flags 0xfdd00000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe7\n", out);
    case 6:
      fputs("device\t\tivory21 at vme32d32 ? csr 0xfdac0000 flags 0xfdb00000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe6\n", out);
    case 5:
      fputs("device\t\tivory20 at vme32d32 ? csr 0xfd8c0000 flags 0xfd900000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe5\n", out);
    case 4:
      fputs("device\t\tivory19 at vme32d32 ? csr 0xfd6c0000 flags 0xfd700000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe4\n", out);
    case 3:
      fputs("device\t\tivory18 at vme32d32 ? csr 0xfd4c0000 flags 0xfd500000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe3\n", out);
    case 2:
      fputs("device\t\tivory17 at vme32d32 ? csr 0xfd2c0000 flags 0xfd300000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe2\n", out);
    case 1:
      fputs("device\t\tivory16 at vme32d32 ? csr 0xfd0c0000 flags 0xfd100000\n", out);
      fputs("\t\tpriority 2 vector ivoryintr 0xe1\n", out);
    }
    break;
  }
  
  return(copy_lines_p);
}



/* Kernel config hacking */

configure_ux_kernel(params)
     struct params *params;
{
  char path[BUFSIZ];
  int ret;
  char *kernel_dir, *source_kernel_name, *ux_kernel_name;

  Printf("\nConfiguring %s kernel...\n", UX_NAME);
  kernel_dir = params->kernel_build_directory;
  source_kernel_name = params->source_kernel_name;
  ux_kernel_name = params->ux_kernel_name;

  /* Update sun/conf.c */
  Sprintf(path, "%s/sun", kernel_dir);
  if (update_file(path, "conf.c", (char *) NULL, 0,
		  conf_next_state, conf_state_transition) == -1)
    goto lose;
  params->ivory_major_device_number = ivorydevno;
  Printf("    [Updated %s/conf.c; Ivory major device number is %d]\n",
		path, params->ivory_major_device_number);

  /* Update sun/str_conf.c */
  if (update_file(path, "str_conf.c", (char *) NULL, 0,
		  str_conf_next_state, str_conf_state_transition) == -1)
    goto lose;
  Printf("    [Updated %s/str_conf.c]\n", path);

  /* Update conf.common/files.cmn */
  Sprintf(path, "%s/conf.common", kernel_dir);
  if (update_file(path, "files.cmn", (char *) NULL, 10000,
		  files_next_state, files_state_transition) == -1)
    goto lose;
  Printf("    [Updated %s/files.cmn]\n", path);

  /* Update or create kernel config file */
  Sprintf(path, "%s/%s/conf", kernel_dir, params->kernel_architecture);
  if (!strcmp(source_kernel_name, ux_kernel_name)) {
    if (update_file(path, source_kernel_name, (char *) NULL, 10000,
		    config_next_state, config_state_transition) == -1)
      goto lose;
    Printf("    [Updated %s/%s]\n", path, ux_kernel_name);
  } else {
    if (update_file(path, source_kernel_name, ux_kernel_name, 10000,
		    config_next_state, config_state_transition) == -1)
      goto lose;
    Printf("    [Created %s/%s from %s/%s]\n",
	   path, ux_kernel_name, path, source_kernel_name);
  }

  /* Configure the kernel */
  Sprintf(path, "cd %s/%s/conf; /etc/config %s",
		 kernel_dir, params->kernel_architecture, ux_kernel_name);
  if ((ret = shell_command(path, 1)) != 0) {
    Fprintf(stderr, ">> Error return code %d from config.\n", ret);
    goto lose;
  }
  /* For some reason, path searching loses about 25% of the time
   * when make(1) calls symorder.  Try to make it too easy to lose. */
  if (access(SYMORDER, F_OK) == 0) {
    Sprintf(path, "%s/%s/%s/symorder", kernel_dir, params->kernel_architecture, ux_kernel_name);
    if (symlink(SYMORDER, path) == -1)
	perror(path);
  }
  Printf("    [Configured %s kernel]\n", UX_NAME);

  /* Compile the kernel */
  Sprintf(path, "cd %s/%s/%s; make",
	  kernel_dir, params->kernel_architecture, ux_kernel_name);
  if ((ret = shell_command(path, 1)) != 0) {
    Fprintf(stderr, ">> Error return code %d from make.\n", ret);
    goto lose;
  }
  Printf("    [Compiled %s kernel]\n", UX_NAME);

  return(0);

 lose:
  Fprintf(stderr, ">> Couldn't configure %s kernel.\n", UX_NAME);
  return(-1);
}

