/*-*- Mode: C; Package: C-user -*-
/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * $Log:	map.c,v $
 * Revision 2.5.1.2  93/02/01  12:56:55  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:52:46  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:42:58  kaufman
 * Baseline for Genera 8.3
 * 
 * 
 */

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/map.c,v 2.5.1.2 93/02/01 12:56:55 kaufman Rel $";
#endif

#include <sys/types.h>
#include <sys/file.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/user.h>
#include <sys/proc.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <fcntl.h>
#include <nlist.h>
#include <stdio.h>

#include "embed.h"
#include "life.h"

/* From <netinet/if_ether.h> */
#define	ETHERTYPE_IP		0x0800		/* IP protocol */

/* Lisp emulation */
struct alist {
  int al_num;
  char *al_name;
};

char *assoc (num, alist)
  int num;
  struct alist alist[];
{
  int i;
  static char buf[100];

  for (i = 0; alist[i].al_name != NULL; i++)
    if (num == alist[i].al_num)
      return(alist[i].al_name);

  sprintf(buf, "%d", num);
  return(buf);
}


/* Useful alists */

static struct alist system_types[] = {
  SystemTypeUX400G, "UX400G",
  SystemTypeXL400, "XL400",
  SystemTypeMacIvory, "MacIvory",
  SystemTypeUX400S, "UX400S",
  SystemTypeUX1200G, "UX1200G",
  SystemTypeXL1200, "XL1200",
  SystemTypeUX1200S, "UX1200S",
  NULL, NULL,
};

static struct alist guest_status[] = {
  NonexistentGuestStatus, "None",
  BrokenGuestStatus, "Broken",
  UninitializedGuestStatus, "Uninit",
  InitializingGuestStatus, "Inting",
  InitializedGuestStatus, "Init",
  StartedGuestStatus, "Start",
  CrashedGuestStatus, "Crash",
  RunningGuestStatus, "Run",
  NULL, NULL,
};

static struct alist fep_statuses[] = {
  HaltedFEPStatus, "Halt",
  RunningFEPStatus, " Run",
  IdleFEPStatus, "Idle",
  NULL, NULL,
};

static struct alist reset_request[] = {
  AreYouThereResetRequest, "Are You There",
  BootResetRequest, "Boot ROM",
  DevicePROMResetRequest, "Device PROM",
  FEPResetRequest, "FEP",
  NoResetRequest, "none",
  LispResetRequest, "Lisp",
  NULL, NULL,
};

static struct alist channel_type[] = {
  EmbDiskChannelType, "Disk",
  EmbConsoleChannelType, "Console",
  EmbNetworkChannelType, "Network",
  EmbCommandChannelType, "RPC",
  EmbSCSIChannelType, "SCSI",
  EmbColdLoadChannelType, "Cold load",
  EmbHostFileChannelType, "Host file",
  EmbMessageChannelType, "Message",
  NULL, NULL,
};

static struct alist message_channel_subtype[] = {
  EmbSerialMessageChannelSubtype, "Serial",
  NULL, NULL,
};


/* /dev/kmem hacking */

static int kmemf = -2;

char *get_proc_name (procp)
     long procp;
{
  struct proc proc;
  char *proc_name, proc_buf[20];

  if (kmemf == -2) {
    /* Open kmem (for digging out pids) */
    if ((kmemf = open("/dev/kmem", O_RDONLY)) == -1)
      perror("/dev/kmem");
  }

  /* Wrong declaration in stdio.h, hurrah */
#define Sprintf (char *) sprintf

  if (kmemf == -1 ||
      lseek(kmemf, procp, L_SET) == -1 ||
      read(kmemf, (char *) &proc, sizeof(proc)) == -1)
    proc_name = Sprintf(proc_buf, "proc 0x%x", procp);
  else
    proc_name = Sprintf(proc_buf, "pid %3d", proc.p_pid);

  return(proc_name);
}


/* Map out communication area */

int verbose = 0;		/* Maybe an option someday */

map_comm_area (ptr, ether_addr_offset, channel_table_p)
     caddr_t ptr;
     EmbPtr ether_addr_offset;
     int channel_table_p;
{
  register EmbCommArea *ep = (EmbCommArea *) ptr;
  char *vers;

#define PLURAL(a) (a) == 1 ? "" : "s"

  printf("System type %s, embedding version %d, ",
	 assoc(ep->system_type, system_types),
	 ep->version);
  if (ep->board_serial_number != 0)
    if (ep->board_serial_number < 16)
      printf("UX400S board #%d, ", ep->board_serial_number+1);
    else
      printf("UX1200S board #%d, ", ep->board_serial_number-15);
  printf("identifier \"%4.4s\" (%s)\n",
	 (char *) &(ep->identifier),
	 ep->identifier == 'DBME' ? "OK" : "clobbered");
  printf("EmbCommArea has %d guest-visible words (%d all told) of %d-word buffer\n",
	 ep->number_of_slots,
	 (sizeof(EmbCommArea)+3)/4,
	 ep->comm_memory_size);

  print_version("Software versions: host", &ep->host_os_version);
  printf(", guest %d.%d, FEP %d",
	 ep->guest_major_version, ep->guest_minor_version,
	 ep->fep_major_version);
  if (ep->fep_minor_version != -1)
    printf(".%d", ep->fep_minor_version);
  putchar('\n');
  printf("Life-support versions: ");
  print_version("kernel", &ep->host_major_version);
  print_version(", life", &ep->host_minor_version);
  print_version(", genera", &ep->boot_version);
  putchar('\n');
#ifdef notdef
  /* For Solstice, host can't figure these out and guest doesn't set them */
  printf("Hardware version %d.%d  serial #%d\n",
	 ep->board_major_version,
	 ep->board_minor_version,
	 ep->board_serial_number);
#endif
  printf("FEP status %s, ", assoc(ep->fep_status, fep_statuses));
  if (ep->fep_cursor || ep->fep_busy || ep->fep_error || ep->fep_lisp_is_loaded) {

#define FIELD(accessor,name) if (ep->accessor) printf("%s, ", name);

    FIELD(fep_cursor, "cursor");
    FIELD(fep_busy, "busy");
    FIELD(fep_error, "error");
    FIELD(fep_lisp_is_loaded, "Lisp loaded");

#undef FIELD

  }
  printf("Lisp status %s\n", assoc(ep->guest_status, guest_status));

  if (channel_table_p == FALSE)
    return;

  printf("Host buffers %d -> %d, FEP %d -> %d, guest %d -> %d",
	 ep->host_buffer_start, ep->host_buffer_start + ep->host_buffer_size,
	 ep->fep_buffer_start, ep->fep_buffer_start + ep->fep_buffer_size,
	 ep->guest_buffer_start, ep->guest_buffer_start + ep->guest_buffer_size);
  if (ep->base_register)
    printf(" plus %d words", ep->base_register>>2);
  putchar('\n');
  printf("Run lights 0%o, reset request %s, ",
	 ep->run_lights,
	 assoc(ep->reset_request, reset_request));
  if (ep->restart_applications)
    printf("restart %d, ", ep->restart_applications);
  if (ep->siv.siv_word == -1)
    puts("interrupts disabled");
  else
    printf("interrupt level %d vector 0x%x\n",
	   ep->signal_interrupt_level, ep->signal_interrupt_vector);
  printf("%d+%d Lisp+PROM resets, %d restart%s requested\n",
	 ep->reset_request_count,
	 ep->device_prom_reset_request_count,
	 ep->restart_applications_count,
	 PLURAL(ep->restart_applications_count));
#ifdef notdef
  /* Merlins have an on-board clock */
  if (ep->clock_signal >= 0)
    printf("Clock signal g%d every %d usec\n",
	   ep->clock_signal,
	   ep->clock_interval);
  else
    puts("No clock signal");
#endif
  if (ep->debug_level) {
    fputs("debug flags:", stdout);
    print_debug_levels(stdout, ep->debug_level, "\n");
  }

  printf("\nSignals: guest->host 0%05o pending  0%05o live\n",
	 ep->guest_to_host_signals,
	 ep->live_guest_to_host_signals);
  printf("         host->guest 0%05o pending  0%05o live\n",
	 ep->host_to_guest_signals,
	 ep->live_host_to_guest_signals);
  describe_host_signal_table(ep);
  describe_host_ether_addrs(ep, ether_addr_offset);

  /* Punt spy stuff, MacIvory memory stuff, etc, for now */

  if (ep->channel_table < 1 || ep->channel_table > MERLIN_II_VME_COMM_AREA_SIZE)
    printf("\nBogus channel table emb pointer %d\n", ep->channel_table);
  else {
    puts("\n** Channel table:");
  
    describe_channel(ptr, ep->channel_table);
  }

}

print_version (name, vers)
     char *name;
     struct version *vers;
{
  if (vers->trunk_major != 255 &&
      vers->trunk_minor != 255) {
    printf("%s %d.%d", name, vers->trunk_major, vers->trunk_minor);
    if (vers->branch_major != 255) {
      printf(".%d", vers->branch_major);
      if (vers->branch_minor != 255)
	printf(".%d", vers->branch_minor);
    }
  }
}


describe_host_ether_addrs (EmbCommAreaPtr, ether_addr_offset)
     EmbCommArea *EmbCommAreaPtr;
     EmbPtr ether_addr_offset;
{
  struct ether_addr *ep = (struct ether_addr *) HostPointer(ether_addr_offset);
  int i;
	
  printf("\n@%d %d host ethernet address%s:",
	 ether_addr_offset, EmbCommAreaPtr->n_host_ether_addrs,
	 EmbCommAreaPtr->n_host_ether_addrs == 1 ? "" : "es");
  for (i = 0; i < EmbCommAreaPtr->n_host_ether_addrs; i++, ep++)
    printf(" %s", ether_ntoa(ep));
  printf("\n");
}


describe_host_signal_table (EmbCommAreaPtr)
     EmbCommArea *EmbCommAreaPtr;
{
  long live = EmbCommAreaPtr->live_guest_to_host_signals;
  int i, j;
  char fn_buf[20];
  char *fn_name;
  struct nlist nl[32];

  if (!live)
    return;

  /* Make one pass over symbol table */
  for (i = 0, j = 0; i < 32; i++)
    if (live & (1<<i)) {
      nl[j].n_value = (unsigned long) EmbCommAreaPtr->SignalHandler[i].fn;
      nl[j++].n_name = NULL;
    }
  if (get_symbol_names("/vmunix", nl, j) == -1)
    perror("get_symbol_names()");
  
  /* Print out signal handler table */
  for (i = 0, j = 0; i < 32; i++)
    if (live & (1<<i)) {
      /* Dig up function name */
      if ((fn_name = nl[j++].n_name) == NULL)
	fn_name = Sprintf(fn_buf, "0x%x", EmbCommAreaPtr->SignalHandler[i].fn);

      printf("  %sh%d  %s  %s(0x%x)  ",
	     i < 10 ? " " : "", i,
	     get_proc_name(EmbCommAreaPtr->SignalHandler[i].proc),
	     fn_name,
	     EmbCommAreaPtr->SignalHandler[i].arg);
      if (EmbCommAreaPtr->SignalHandler[i].flag & SIGF_RESET)
	printf("reset ");
      if (EmbCommAreaPtr->SignalHandler[i].flag & SIGF_INTERRUPT)
	printf("intr ");
      if (EmbCommAreaPtr->SignalHandler[i].count != 1)
	printf("count %d ", EmbCommAreaPtr->SignalHandler[i].count);
      putchar('\n');
    }
}

#ifdef notdef
describe_select_signals (EmbCommAreaPtr)
     EmbCommArea *EmbCommAreaPtr;
{
  struct ivory_state ivory;

  nlist();

  lseek();

  read();
}
#endif

describe_channel (EmbCommAreaPtr, ptr)
     EmbCommArea *EmbCommAreaPtr;
     EmbPtr ptr;
{
  EmbDiskChannel *chan = (EmbDiskChannel *) HostPointer(ptr);

  printf("@%03d: type %d (%s), unit %d",
	 ptr,
	 chan->type,
	 assoc(chan->type, channel_type),
	 chan->unit);

  switch(chan->type) {
  case EmbDiskChannelType:
    describe_disk_channel(EmbCommAreaPtr, chan);
    break;

  case EmbNetworkChannelType:
    describe_network_channel(EmbCommAreaPtr, chan);
    break;

  case EmbColdLoadChannelType:
    describe_cold_load_channel(EmbCommAreaPtr, chan);
    break;

#ifdef notdef
  case EmbSCSIChannelType:
    describe_scsi_channel(EmbCommAreaPtr, chan);
    break;

  case EmbConsoleChannelType:
    describe_console_channel(EmbCommAreaPtr, chan);
    break;

  case EmbCommandChannelType:
    describe_RPC_channel(EmbCommAreaPtr, chan);
    break;
#endif

  case EmbMessageChannelType:
    describe_message_channel(EmbCommAreaPtr, chan);
    break;

  case EmbHostFileChannelType:
    describe_host_file_channel(EmbCommAreaPtr, chan);
    break;

  default:
    puts("");
    break;
  }

  if (chan->next != NullEmbPtr)
    describe_channel(EmbCommAreaPtr, chan->next);
}

/* --- Borrowed from kernel */
long EmbQueueFilled (EmbCommAreaPtr, qp) /* Number of non-free elements */
     EmbCommArea *EmbCommAreaPtr;
     EmbQueue* qp;
{
  register long put = qp->put_index;
  register long take = qp->take_index;

  if ( put >= take )
    return ( put - take );
  else return ( put - take + qp->queue_size );
}

describe_queue (EmbCommAreaPtr, qptr, name, host_signal_p)
     EmbCommArea *EmbCommAreaPtr;
     EmbPtr qptr;
     char *name;
     int host_signal_p;
{
  EmbQueue *queue = HostPointer(qptr);
  int elts;

  printf("    %s queue @%d: %d %d-byte element%s (",
	 name,
	 qptr,
	 queue->queue_size,
	 queue->element_size,
	 PLURAL(queue->queue_size));

  if (elts = EmbQueueFilled(EmbCommAreaPtr, queue))
    printf("%d element%s", elts, PLURAL(elts));
  else
    printf("empty");

  if (queue->signal >= 0)
    printf("), signal %c%d\n",
	   host_signal_p ? 'h' : 'g', queue->signal);
  else
    printf("), no signal\n");

  return(((sizeof(EmbQueue) - sizeof(EmbPtr)) / sizeof(EmbPtr)) +
	 (queue->queue_size * (queue->element_size / sizeof(EmbPtr))));
}

describe_disk_channel (EmbCommAreaPtr, chan)
     EmbCommArea *EmbCommAreaPtr;
     EmbDiskChannel *chan;
{
  int size = sizeof(*chan)/sizeof(EmbPtr);

  printf(", %d Ivory pages%s",
	 chan->number_of_pages,
	 chan->error_pending ? ", error pending" : "");
  if (!chan->initialized_p)
    printf(", uninitialized");
  puts("");

  size += describe_queue(EmbCommAreaPtr, chan->command_queue, "Command", 1);
  size += describe_queue(EmbCommAreaPtr, chan->status_queue, "Status", 0);
  if (verbose)
    printf("    %d words allocated to channel\n", size);
}

describe_network_channel (EmbCommAreaPtr, chan)
     EmbCommArea *EmbCommAreaPtr;
     EmbNetChannel *chan;
{
  int size = sizeof(*chan)/sizeof(EmbPtr);
  int high = chan->hardware_address_high, low = chan->hardware_address_low;
  char ifname[9];

#ifdef IVORY_EMBIF
  if (chan->emb_if_unit == -1)
    printf(", no emb if");
  else
    printf(", emb%d", chan->emb_if_unit);
#endif
  printf(", status %d", chan->status);
  if (!chan->initialized_p)
    printf(", uninitialized");
  puts("");


  printf("    ");
  if (chan->name_0 != 0) {
    int i, j;

    for (i = 0, j = 0; i < 4; i++, j+=8)
      if (!(ifname[i] = (chan->name_0 >> j) & 0377))
	break;

    if (chan->name_1 != 0)
      for (j = 0; i < 8; i++, j+=8)
	if (!(ifname[i] = (chan->name_1 >> j) & 0377))
	  break;

    ifname[i] = '\0';
    printf("interface %s, ", ifname);
  }
  printf("hw address %x:%x:%x:%x:%x:%x\n",
	 high & 0377,
	 (high >> 8) & 0377,
	 (high >> 16) & 0377,
	 (high >> 24) & 0377,
	 low & 0377,
	 (low >> 8) & 0377);


  /* Addresses */
  if (chan->host_primary_protocol == -1)
    fputs("    No host address, ", stdout);
  else if (chan->host_primary_protocol == ETHERTYPE_IP)
    printf("    Host IP address %s, ",
           inet_ntoa(*(struct in_addr *) &chan->host_primary_address));
  else
    printf("    Host protocol %d address 0x%x, ",
	   chan->host_primary_protocol, chan->host_primary_address);
  if (chan->guest_primary_protocol == -1)
    puts("no guest address");
  else if (chan->guest_primary_protocol == ETHERTYPE_IP)
    printf("guest IP address %s\n",
           inet_ntoa(*(struct in_addr *) &chan->guest_primary_address));
  else
    printf("guest protocol %d address 0x%x\n",
	   chan->guest_primary_protocol, chan->guest_primary_address);

  /* Meters */
  printf("    %d crc/align errors, %d aborts, %d coll, %d dropped\n",
	 chan->if_ierrors, chan->if_oerrors, chan->if_collisions, chan->if_dropped);

  /* Queues */
  size += describe_queue(EmbCommAreaPtr, chan->xmit_guest_to_host_queue,
			 "xmit guest->host", 1);
  size += describe_queue(EmbCommAreaPtr, chan->xmit_host_to_guest_queue,
			 "xmit host->guest", 0);
  size += describe_queue(EmbCommAreaPtr, chan->recv_guest_to_host_queue,
			 "recv guest->host", 1);
  size += describe_queue(EmbCommAreaPtr, chan->recv_host_to_guest_queue,
			 "recv host->guest", 0);
  if (verbose)
    printf("    %d words allocated to channel\n", size);
}

describe_cold_load_channel (EmbCommAreaPtr, chan)
     EmbCommArea *EmbCommAreaPtr;
     EmbColdLoadChannel *chan;
{
  int size = sizeof(*chan)/sizeof(EmbPtr);
  char buf[COLD_LOAD_STRING_TOTAL_SIZE+1];

  if (chan->selproc != NULL)
    printf(", %s selecting", get_proc_name(chan->selproc));
  puts("");
  if (chan->string_length > 0) {
    bcopy(chan->string, buf, chan->string_length);
    buf[chan->string_length] = '\0';
    printf("    FEP progress note: %s (%d/%d)\n",
	   buf, chan->progress_numerator, chan->progress_denominator);
  } else
    puts("    No progress note");
  size += describe_queue(EmbCommAreaPtr, chan->display_output_queue, "display output", 1);
  size += describe_queue(EmbCommAreaPtr, chan->keyboard_input_queue, "keyboard input", 0);
  if (verbose)
    printf("    %d words allocated to channel\n", size);
}

describe_message_channel (EmbCommAreaPtr, chan)
     EmbCommArea *EmbCommAreaPtr;
     EmbMessageChannel *chan;
{
  int size = sizeof(*chan)/sizeof(EmbPtr);

  printf(", subtype %s", assoc(chan->subtype, message_channel_subtype));
  if (chan->selproc != NULL)
    printf(", %s selecting", get_proc_name(chan->selproc));
  puts("");
  if (chan->guest_to_host_impulse)
    printf("guest->host impulse %d", chan->guest_to_host_impulse);
  if (chan->guest_to_host_impulse && chan->host_to_guest_impulse)
    printf(", ");
  if (chan->host_to_guest_impulse)
    printf("host->guest impulse %d", chan->host_to_guest_impulse);
  if (chan->guest_to_host_impulse || chan->host_to_guest_impulse)
    puts("");
  size += describe_queue(EmbCommAreaPtr, chan->guest_to_host_queue, "guest->host", 1);
  size += describe_queue(EmbCommAreaPtr, chan->guest_to_host_return_queue,
			 "guest->host return", 0);
  size += describe_queue(EmbCommAreaPtr, chan->host_to_guest_supply_queue,
			 "host->guest supply", 1);
  size += describe_queue(EmbCommAreaPtr, chan->host_to_guest_queue, "host->guest", 0);
  if (verbose)
    printf("    %d words allocated to channel\n", size);
}

describe_host_file_channel (EmbCommAreaPtr, chan)
     EmbCommArea *EmbCommAreaPtr;
     EmbHostFileChannel *chan;
{
  int size = sizeof(*chan)/sizeof(EmbPtr);

  if (chan->selproc != NULL)
    printf(", %s selecting", get_proc_name(chan->selproc));
  puts("");
  size += describe_queue(EmbCommAreaPtr, chan->command_queue, "command", 1);
  size += describe_queue(EmbCommAreaPtr, chan->reply_queue, "reply", 0);

  if (verbose)
    printf("    %d words allocated to channel\n", size);
}

/*--- lose, lose */
panic (why)
     char *why;
{
  fprintf(stderr, "panic: %s\n", why);
  abort();
}
