/*>
 *> *****************************************************************************************
 *> ** (c) Copyright 1993-1989 Symbolics, Inc.  All rights reserved.
 *> ** Portions of font library Copyright (c) 1984 Bitstream, Inc.  All Rights Reserved.
 *>
 *>    The software, data, and information contained herein are proprietary 
 *> to, and comprise valuable trade secrets of, Symbolics, Inc., which intends 
 *> to keep such software, data, and information confidential and to preserve 
 *> them as trade secrets.  They are given in confidence by Symbolics pursuant 
 *> to a written license agreement, and may be used, copied, transmitted, and 
 *> stored only in accordance with the terms of such license.
 *> 
 *> Symbolics, Symbolics 3600, Symbolics 3670 (R), Symbolics 3675 (R), Symbolics
 *> 3630, Symbolics 3640, Symbolics 3645 (R), Symbolics 3650 (R), Symbolics 3653,
 *> Symbolics 3620 (R), Symbolics 3610 (R), Symbolics Common Lisp (R),
 *> Symbolics-Lisp (R), Zetalisp (R), Genera (R), Wheels (R), Dynamic Windows (R),
 *> SmartStore (R), Semanticue (R), Frame-Up (R), Firewall (R), Document Examiner (R),
 *> Delivery Document Examiner, "Your Next Step in Computing" (R), Ivory, MacIvory,
 *> MacIvory model 1, MacIvory model 2, MacIvory model 3, XL400, XL1200, XL1201,
 *> Symbolics UX400S, Symbolics UX1200S, NXP1000, Symbolics C, Symbolics Pascal (R),
 *> Symbolics Prolog, Symbolics Fortran (R), CLOE (R), CLOE Application Generator,
 *> CLOE Developer, CLOE Runtime, Common Lisp Developer, Symbolics Concordia, Joshua,
 *> Statice (R), and Minima are trademarks of Symbolics, Inc.
 *> 
 *> RESTRICTED RIGHTS LEGEND
 *>    Use, duplication, and disclosure by the Government are subject to restrictions 
 *> as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
 *> Software Clause at DFAR 52.227-7013.
 *> 
 *>      Symbolics, Inc.
 *>      6 Concord Farms
 *>      555 Virginia Road
 *>      Concord, Massachusetts 01742-2727
 *>      United States of America
 *>      508-287-1000
 *>
 *> *****************************************************************************************
 *>
 */

/*
 * $Log:	servicesd.c,v $
 * Revision 2.5.1.3  93/02/01  13:44:06  kaufman
 * PollRPC is a void now; don't try to check its return value.
 * 
 * Revision 2.5.1.2  93/02/01  12:57:06  kaufman
 * Update copyright notices
 * 
 * Revision 2.5.1.1  93/02/01  11:53:01  kaufman
 * Baseline for distributed software
 * 
 * Revision 2.5  93/02/01  11:43:30  kaufman
 * Baseline for Genera 8.3
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Header: /usr/share/local/symbolics/src/RCS/servicesd.c,v 2.5.1.3 93/02/01 13:44:06 kaufman Exp $";
#endif

#include <sys/types.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <setjmp.h>
#include <stdio.h>
#include "RPC.h"

#define CHKERR(a, b) if ((err = a) != noErr) FATAL(b)
#define FATAL(why) { errno = err; perror(why); abort(); }

int (*rpc_return_hook)() = NULL;
jmp_buf skip_rpc;

main(argc, argv)
     int argc;
     char **argv;
{
  int err;
  int fd, i;
  fd_set read;
  char *cp, *index();

  rpc_server_name = "UX Support Server";
  rpc_server_version = "$Revision: 2.5.1.3 $"+11;
  if ((cp = index(rpc_server_version, ' ')) != NULL)
    *cp = '\0';
  
  InitializeRPC();

  CHKERR(initialize_unix_support_server_server(), "initialize_unix_support_server_server");
  CHKERR(initialize_solstice_embedded_serial_server(),
	 "initialize_solstice_embedded_serial_server");
  initialize_predefined_remote_entries_server();
  CHKERR(udp_agent_open((char *) 0, IPPORT_RPC), "udp_agent_open");

  fd = RPCAgentFileDescriptor();
  for (;;) {
    FD_ZERO(&read);
    FD_SET(fd, &read);
    if (select(fd+1, &read, NULL, NULL, NULL) < 0 && errno != EINTR) {
      perror("select");
      exit(1);
    }
#ifdef USE_TCP
    if (FD_ISSET(fd, &read) && !ioctl(fd, FIONREAD, &i) && !i)
      /* select() for read but nothing to read means the connection wants to close */
      break;
#endif

    if (setjmp(skip_rpc) == 0)
      PollRPC();

    if (rpc_return_hook != NULL) {
      err = (*rpc_return_hook)();
      exit(err);
    }
  }

  CHKERR(CloseRPC(), "CloseRPC");
}

void BusyWait(allow_rpc)
     int allow_rpc;
{
  if (allow_rpc)
    PollRPC();
}


#include <sys/file.h>
#include <nlist.h>

struct nlist nl[] = {
#define NL_VERSION 0
  {"_version"},
  NULL,
};

char *lookup_os_release ()
{
  int fd, found_it = 0;
  static char buf[BUFSIZ];

  if (found_it)
    return(buf);

  buf[0] = '\0';
  if (nlist("/vmunix", nl) == -1) {
    return(NULL);
  }

  if ((fd = open("/dev/kmem", O_RDONLY)) == -1) {
    return(NULL);
  }

  if (lseek(fd, nl[NL_VERSION].n_value, L_SET) == -1) {
    close(fd);
    return(NULL);
  }

  if (read(fd, buf, BUFSIZ) == -1) {
    close (fd);
    return(NULL);
  }

  found_it = 1;
  close(fd);
  return(buf);
}

