/* -*- Mode: C; Package: C-USER; Search-list: RPC -*- */


/* Server portion of UNIX-SUPPORT-SERVER remote module version 1
   Generated from S:>rel-8-3>sys>embedding>ux>rpc-services.lisp.30
   by dodds on Thursday the twelfth of November, 1992; 7:56:56 pm */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <stdio.h>
#include <errno.h>
#include "RPC.h"

static OSErr set_bsd_unix_clock_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                    long TransactionID,
                                                    XDRBlock CallXDRBlock,
                                                    long * the_XDRPointer,
                                                    long * XDRLimit));

static OSErr set_bsd_unix_clock_handler(the_XDRAgent,
                                        TransactionID,
                                        CallXDRBlock,
                                        the_XDRPointer,
                                        XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  OSErr system_error_code = noErr;
  
  long seconds;
  long microseconds;
  seconds = *(XDRPointer++);
  microseconds = *(XDRPointer++);
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    { struct timeval new;
      new.tv_sec = seconds;
      new.tv_usec = microseconds;
      if(settimeofday(&new, (struct timezone *)NULL))
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        }
      else { system_error_code = RPCNoValues(XDR_Agent,
                                             TransactionID);
        if(system_error_code)goto _end_;
        }
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr yp_domain_name_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                long TransactionID,
                                                XDRBlock CallXDRBlock,
                                                long * the_XDRPointer,
                                                long * XDRLimit));

static OSErr yp_domain_name_handler(the_XDRAgent, TransactionID,
                                    CallXDRBlock, the_XDRPointer,
                                    XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  long length_tem_1;
  OSErr system_error_code = noErr;
  
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    { char buf[BUFSIZ];
      if(getdomainname(buf, BUFSIZ) == - 1)
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        }
      else { { system_error_code = XDRInitiateReply(XDR_Agent,
                                                    TransactionID,
                                                    (long)((long)(strlen(buf) +
                                                                  7) >> 2),
                                                    &ReplyXDRBlock,
                                                    &the_XDRPointer,
                                                    &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          length_tem_1 = strlen(buf);
          *(XDRPointer++) = length_tem_1;
          CopyMemory((void *)buf, (void *)XDRPointer,
                     (long)length_tem_1);
          XDRPointer += (length_tem_1 + 3) >> 2;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendReply(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        }
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr nfs_mount_points_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                  long TransactionID,
                                                  XDRBlock CallXDRBlock,
                                                  long * the_XDRPointer,
                                                  long * XDRLimit));

static OSErr nfs_mount_points_handler(the_XDRAgent,
                                      TransactionID,
                                      CallXDRBlock,
                                      the_XDRPointer,
                                      XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  long length_tem_1, length_tem_2;
  OSErr system_error_code = noErr;
  
  enum { fstab, mtab }
  registry;
  long last_mtime;
  registry = (int)*(XDRPointer++);
  last_mtime = *(XDRPointer++);
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    { FILE * fp = NULL;
      struct stat st;
      char * cp = NULL, *file = NULL, *calloc(); /* Choose file name */
      if(registry == fstab)file = "/etc/fstab";
      else if(registry == mtab)file = "/etc/mtab";
      else { { system_error_code = XDRInitiateError(XDR_Agent,
                                                    CallXDRBlock,
                                                    (long)1,
                                                    (long)-42,
                                                    (long)1,
                                                    &ReplyXDRBlock,
                                                    &the_XDRPointer,
                                                    &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = ENOENT;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        goto done;
        }
      /* Check mtime */
      if(stat(file, &st) == - 1)
      { perror(file);
        { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        goto done;
        }
      else if(last_mtime == st.st_mtime)
      { { system_error_code = XDRInitiateReply(XDR_Agent,
                                               TransactionID,
                                               (long)((long)(strlen("") +
                                                             7) >> 2) +
                                               1, &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          length_tem_1 = strlen("");
          *(XDRPointer++) = length_tem_1;
          CopyMemory((void *)"", (void *)XDRPointer,
                     (long)length_tem_1);
          XDRPointer += (length_tem_1 + 3) >> 2;
          *(XDRPointer++) = (st.st_mtime);
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendReply(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        goto done;
        }
      /* Open file and slurp it in */
      cp = calloc(st.st_size + 1, sizeof(char));
      if(cp == NULL)
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = EFBIG;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        goto done;
        }
      if((fp = fopen(file, "r")) == NULL)
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        goto done;
        }
      fread(cp, sizeof(char), st.st_size, fp);
      cp[st.st_size] = '\0';
      { system_error_code = XDRInitiateReply(XDR_Agent,
                                             TransactionID,
                                             (long)((long)(strlen(cp) +
                                                           7) >> 2) +
                                             1, &ReplyXDRBlock,
                                             &the_XDRPointer,
                                             &XDRLimit);
        if(system_error_code)goto _end_;
        XDRPointer = the_XDRPointer;
        length_tem_2 = strlen(cp);
        *(XDRPointer++) = length_tem_2;
        CopyMemory((void *)cp, (void *)XDRPointer, (long)length_tem_2);
        XDRPointer += (length_tem_2 + 3) >> 2;
        *(XDRPointer++) = (st.st_mtime);
        XDRVerifyPointer(XDRPointer, XDRLimit);
        system_error_code = XDRSendReply(XDR_Agent,
                                         ReplyXDRBlock);
        if(system_error_code)goto _end_;
        };
      done : if(cp != NULL)free(cp);
      if(fp != NULL)fclose(fp);
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr add_multicast_mask_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                    long TransactionID,
                                                    XDRBlock CallXDRBlock,
                                                    long * the_XDRPointer,
                                                    long * XDRLimit));

static OSErr add_multicast_mask_handler(the_XDRAgent,
                                        TransactionID,
                                        CallXDRBlock,
                                        the_XDRPointer,
                                        XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  long length_tem_1;
  OSErr system_error_code = noErr;
  
  char * name;
  unsigned char * mask;
  length_tem_1 = *(XDRPointer++);
  name = (char *)XDRPointer - 1;
  CopyMemory((void *)(name + 1), (void *)name, length_tem_1);
  name[length_tem_1] = 0;
  XDRPointer += (length_tem_1 + 3) >> 2;
  mask = (void *)XDRPointer;
  XDRPointer += 2;
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    struct ifreq ifr;
    int s;
    strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));
    ifr.ifr_addr.sa_family = AF_UNSPEC;
    bcopy(mask, ifr.ifr_addr.sa_data, 6);
    if((s = socket(AF_UNSPEC, SOCK_RAW, 0)) == - 1)
    { { system_error_code = XDRInitiateError(XDR_Agent,
                                             CallXDRBlock,
                                             (long)1,
                                             (long)-42,
                                             (long)1,
                                             &ReplyXDRBlock,
                                             &the_XDRPointer,
                                             &XDRLimit);
        if(system_error_code)goto _end_;
        XDRPointer = the_XDRPointer;
        *(XDRPointer++) = errno;
        XDRVerifyPointer(XDRPointer, XDRLimit);
        system_error_code = XDRSendError(XDR_Agent,
                                         ReplyXDRBlock);
        if(system_error_code)goto _end_;
        };
      }
    else { if(ioctl(s, SIOCADDMULTI, ifr) == - 1)
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        }
      else { system_error_code = RPCNoValues(XDR_Agent,
                                             TransactionID);
        if(system_error_code)goto _end_;
        }
      close(s);
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr delete_multicast_mask_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                       long TransactionID,
                                                       XDRBlock CallXDRBlock,
                                                       long * the_XDRPointer,
                                                       long * XDRLimit));

static OSErr delete_multicast_mask_handler(the_XDRAgent,
                                           TransactionID,
                                           CallXDRBlock,
                                           the_XDRPointer,
                                           XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  long length_tem_1;
  OSErr system_error_code = noErr;
  
  char * name;
  unsigned char * mask;
  length_tem_1 = *(XDRPointer++);
  name = (char *)XDRPointer - 1;
  CopyMemory((void *)(name + 1), (void *)name, length_tem_1);
  name[length_tem_1] = 0;
  XDRPointer += (length_tem_1 + 3) >> 2;
  mask = (void *)XDRPointer;
  XDRPointer += 2;
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    struct ifreq ifr;
    int s;
    strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));
    ifr.ifr_addr.sa_family = AF_UNSPEC;
    bcopy(mask, ifr.ifr_addr.sa_data, 6);
    if((s = socket(AF_UNSPEC, SOCK_RAW, 0)) == - 1)
    { { system_error_code = XDRInitiateError(XDR_Agent,
                                             CallXDRBlock,
                                             (long)1,
                                             (long)-42,
                                             (long)1,
                                             &ReplyXDRBlock,
                                             &the_XDRPointer,
                                             &XDRLimit);
        if(system_error_code)goto _end_;
        XDRPointer = the_XDRPointer;
        *(XDRPointer++) = errno;
        XDRVerifyPointer(XDRPointer, XDRLimit);
        system_error_code = XDRSendError(XDR_Agent,
                                         ReplyXDRBlock);
        if(system_error_code)goto _end_;
        };
      }
    else { if(ioctl(s, SIOCDELMULTI, ifr) == - 1)
      { { system_error_code = XDRInitiateError(XDR_Agent,
                                               CallXDRBlock,
                                               (long)1,
                                               (long)-42,
                                               (long)1,
                                               &ReplyXDRBlock,
                                               &the_XDRPointer,
                                               &XDRLimit);
          if(system_error_code)goto _end_;
          XDRPointer = the_XDRPointer;
          *(XDRPointer++) = errno;
          XDRVerifyPointer(XDRPointer, XDRLimit);
          system_error_code = XDRSendError(XDR_Agent,
                                           ReplyXDRBlock);
          if(system_error_code)goto _end_;
          };
        }
      else { system_error_code = RPCNoValues(XDR_Agent,
                                             TransactionID);
        if(system_error_code)goto _end_;
        }
      close(s);
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr raw_os_release_handler PROTO_ARGS((XDRAgent the_XDRAgent,
                                                long TransactionID,
                                                XDRBlock CallXDRBlock,
                                                long * the_XDRPointer,
                                                long * XDRLimit));

static OSErr raw_os_release_handler(the_XDRAgent, TransactionID,
                                    CallXDRBlock, the_XDRPointer,
                                    XDRLimit) 
XDRAgent the_XDRAgent;
long TransactionID;
XDRBlock CallXDRBlock;
long * the_XDRPointer;
long * XDRLimit;
{ XDRAgent XDR_Agent = the_XDRAgent;
  register long * XDRPointer = the_XDRPointer;
  long length_tem_1;
  OSErr system_error_code = noErr;
  
  XDRVerifyPointer(XDRPointer, XDRLimit);
  { XDRBlock ReplyXDRBlock;
    char * release, *lookup_os_release();
    release = lookup_os_release();
    if(release == NULL)
    { { system_error_code = XDRInitiateError(XDR_Agent,
                                             CallXDRBlock,
                                             (long)1,
                                             (long)-42,
                                             (long)1,
                                             &ReplyXDRBlock,
                                             &the_XDRPointer,
                                             &XDRLimit);
        if(system_error_code)goto _end_;
        XDRPointer = the_XDRPointer;
        *(XDRPointer++) = errno;
        XDRVerifyPointer(XDRPointer, XDRLimit);
        system_error_code = XDRSendError(XDR_Agent,
                                         ReplyXDRBlock);
        if(system_error_code)goto _end_;
        };
      }
    else { { system_error_code = XDRInitiateReply(XDR_Agent,
                                                  TransactionID,
                                                  (long)((long)(strlen(release) +
                                                                7) >> 2),
                                                  &ReplyXDRBlock,
                                                  &the_XDRPointer,
                                                  &XDRLimit);
        if(system_error_code)goto _end_;
        XDRPointer = the_XDRPointer;
        length_tem_1 = strlen(release);
        *(XDRPointer++) = length_tem_1;
        CopyMemory((void *)release, (void *)XDRPointer,
                   (long)length_tem_1);
        XDRPointer += (length_tem_1 + 3) >> 2;
        XDRVerifyPointer(XDRPointer, XDRLimit);
        system_error_code = XDRSendReply(XDR_Agent,
                                         ReplyXDRBlock);
        if(system_error_code)goto _end_;
        };
      }
    _end_ :;
    }
  return(system_error_code);
  }

static OSErr unix_support_server_server PROTO_ARGS((XDRAgent agent,
                                                    long TransactionID,
                                                    long entry_number,
                                                    XDRBlock block,
                                                    long * pointer,
                                                    long * limit));


static OSErr unix_support_server_server(agent, TransactionID,
                                        entry_number,
                                        block, pointer,
                                        limit) 
XDRAgent agent;
long TransactionID, entry_number;
XDRBlock block;
long * pointer;
long * limit;
{ register FunctionPtr handler;
  switch((int)entry_number)
  { case 11 : handler = set_bsd_unix_clock_handler;
    break;
    case 20 : handler = yp_domain_name_handler;
    break;
    case 21 : handler = nfs_mount_points_handler;
    break;
    case 30 : handler = add_multicast_mask_handler;
    break;
    case 31 : handler = delete_multicast_mask_handler;
    break;
    case 40 : handler = raw_os_release_handler;
    break;
    default : return(RPC_PROC_UNAVAIL);
    };
  return((*handler)(agent, TransactionID, block, pointer,
                    limit));
  }


extern OSErr initialize_unix_support_server_server PROTO_ARGS((void));

OSErr initialize_unix_support_server_server()
{ return(RegisterModule((long)0x7F000141, (long)1, unix_support_server_server));
  }
